// Get rid of this crap
#include "sidl_config.h"

#ifndef included_SIDL_cxx_hh
#include "SIDL_cxx.hh"
#endif

#ifndef included_SIDL_BaseClass_IOR
#include "SIDL/BaseClass_IOR/BaseClass_IOR.h"
#endif

// Forward declaration
namespace SIDL {
  // Symbol "SIDL.BaseClass"
  class BaseClass;
} // end namespace SIDL

// Array specialization
namespace SIDL {
  template<>
  class array< ::SIDL::BaseClass >;
} // end namespace SIDL

#ifndef included_SIDL_BaseClass_stub
#define included_SIDL_BaseClass_stub

//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_stub
#include "SIDL/Loader/Loader.hh"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface/BaseInterface.hh"
#endif

namespace SIDL {
  // Symbol "SIDL.BaseClass"
  class BaseClass : public ::SIDL::StubBase {

  // Type definitions 
  public:
    typedef struct SIDL_BaseClass__object ior_t;
    typedef struct SIDL_BaseClass__external ext_t;
    typedef struct SIDL_BaseClass__sepv sepv_t;

  private:
    // Pointer to IOR
    ior_t *d_self;

    // Weak references which do not add/deleteRef() (used by Impl)
    bool d_weak_reference;

    // Pointer to function table (DLL loadable symbols) which is shared among instances
    static const ext_t *s_ext;

  // Static constructor
  public:
    static ::SIDL::BaseClass _create() {
      ::SIDL::BaseClass self((*_get_ext()->createObject)());
      // The reference count is now 2
      //   1 from createObject()
      //   1 from IOR to C++ conversion
      // Decrement this count back down to one
      self.deleteReference();
      return self;
    }

  // Constructors/Destructors 
  public:
    // Default constructor
    BaseClass() : d_self(0), d_weak_reference(false) {}

    // Default destructor
    virtual ~BaseClass() {
      if (d_self != 0) {
        deleteReference();
      }
    }

    // Copy constructor
    BaseClass(const BaseClass& original) {
      d_self = const_cast< ior_t * >(original.d_self);
      d_weak_reference = original.d_weak_reference;
      if (d_self != 0) {
        addReference();
      }
    }

    // Assignment operator
    BaseClass& operator=(const BaseClass& rhs) {
      if (d_self != rhs.d_self) {
        if (d_self != 0) {
          deleteReference();
        }
        d_self = const_cast< ior_t * >(rhs.d_self);
        d_weak_reference = rhs.d_weak_reference;
        if (d_self != 0) {
          addReference();
        }
      }
      return *this;
    }

  // Casting Operators 
  public:
    // Conversion from IOR to C++ class
    BaseClass(BaseClass::ior_t *ior) : d_self(ior), d_weak_reference(false) {
      if (d_self != 0) {
        addReference();
      }
    }

    // Alternate constructor which does not call addReference()
    //   also sets d_weak_reference = isWeak
    //   used by Impl (fixes bug #275)
    BaseClass(BaseClass::ior_t *ior, bool isWeak) : d_self(ior), d_weak_reference(isWeak) {}

    // Conversion from a StubBase
    BaseClass(const ::SIDL::StubBase& base) {
      d_self = reinterpret_cast< ior_t * >(base._cast("SIDL.BaseClass"));
      d_weak_reference = false;
      if (d_self != 0) {
        addReference();
      }
    }

  // Binding specific methods 
  public:
    ior_t *_get_ior() {return d_self;}

    const ior_t *_get_ior() const {return d_self;}

    bool _is_nil() const {return(d_self == 0);}

    bool _not_nil() const {return(d_self != 0);}

    bool operator!() const {return(d_self == 0);}

    static const ext_t *_get_ext() throw ();

  public:
    virtual void *_cast(const char *type) const {
      void *ptr = 0;

      if (d_self != 0) {
        ptr = reinterpret_cast< void * >((*d_self->d_epv->f__cast_ior)(d_self, type));
      }
      return ptr;
    }

  // User defined methods 
  public:
    void
    SIDL::BaseClass::addReference()
    throw ()
    ;
    
    void
    SIDL::BaseClass::deleteReference()
    throw ()
    ;
    
    bool
    SIDL::BaseClass::isSame(
      /*in*/ ::SIDL::BaseInterface iobj)
    throw ()
    ;
    
    ::SIDL::BaseInterface
    SIDL::BaseClass::queryInterface(
      /*in*/ std::string name)
    throw ()
    ;
    
    bool
    SIDL::BaseClass::isInstanceOf(
      /*in*/ std::string name)
    throw ()
    ;
    
  }; // end class BaseClass
} // end namespace SIDL

// Array specialization
namespace SIDL {
  template <>
  class array< ::SIDL::BaseClass > : public array_mixin<struct SIDL_BaseClass__array, struct SIDL_BaseClass__object *, ::SIDL::BaseClass> {
  public:
    // Default constructor
    array() : array_mixin<struct SIDL_BaseClass__array, struct SIDL_BaseClass__object *, ::SIDL::BaseClass>() {}

    // Constructor/Casting operator
    array(struct SIDL_BaseClass__array *src) : array_mixin<struct SIDL_BaseClass__array, struct SIDL_BaseClass__object *, ::SIDL::BaseClass>(src) {}
  };
}

#endif /*included_SIDL_BaseClass_stub*/
