// Get rid of this crap
#include "sidl_config.h"

#ifndef included_SIDL_cxx_hh
#include "SIDL_cxx.hh"
#endif

#ifndef included_SIDL_BaseInterface_IOR
#include "SIDL/BaseInterface_IOR/BaseInterface_IOR.h"
#endif

// Forward declaration
namespace SIDL {
  // Symbol "SIDL.BaseInterface"
  class BaseInterface;
} // end namespace SIDL

// Array specialization
namespace SIDL {
  template<>
  class array< ::SIDL::BaseInterface >;
} // end namespace SIDL

#ifndef included_SIDL_BaseInterface_stub
#define included_SIDL_BaseInterface_stub

//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_stub
#include "SIDL/Loader/Loader.hh"
#endif

namespace SIDL {
  // Symbol "SIDL.BaseInterface"
  class BaseInterface : public ::SIDL::StubBase {

  // Type definitions 
  public:
    typedef struct SIDL_BaseInterface__object ior_t;
    typedef struct SIDL_BaseInterface__external ext_t;

  private:
    // Pointer to IOR
    ior_t *d_self;

    // Weak references which do not add/deleteRef() (used by Impl)
    bool d_weak_reference;

    // Pointer to function table (DLL loadable symbols) which is shared among instances
    static const ext_t *s_ext;

  // Constructors/Destructors 
  public:
    // Default constructor
    BaseInterface() : d_self(0), d_weak_reference(false) {}

    // Default destructor
    virtual ~BaseInterface() {
      if (d_self != 0) {
        deleteReference();
      }
    }

    // Copy constructor
    BaseInterface(const BaseInterface& original) {
      d_self = const_cast< ior_t * >(original.d_self);
      d_weak_reference = original.d_weak_reference;
      if (d_self != 0) {
        addReference();
      }
    }

    // Assignment operator
    BaseInterface& operator=(const BaseInterface& rhs) {
      if (d_self != rhs.d_self) {
        if (d_self != 0) {
          deleteReference();
        }
        d_self = const_cast< ior_t * >(rhs.d_self);
        d_weak_reference = rhs.d_weak_reference;
        if (d_self != 0) {
          addReference();
        }
      }
      return *this;
    }

  // Casting Operators 
  public:
    // Conversion from IOR to C++ class
    BaseInterface(BaseInterface::ior_t *ior) : d_self(ior), d_weak_reference(false) {
      if (d_self != 0) {
        addReference();
      }
    }

    // Alternate constructor which does not call addReference()
    //   also sets d_weak_reference = isWeak
    //   used by Impl (fixes bug #275)
    BaseInterface(BaseInterface::ior_t *ior, bool isWeak) : d_self(ior), d_weak_reference(isWeak) {}

    // Conversion from a StubBase
    BaseInterface(const ::SIDL::StubBase& base) {
      d_self = reinterpret_cast< ior_t * >(base._cast("SIDL.BaseInterface"));
      d_weak_reference = false;
      if (d_self != 0) {
        addReference();
      }
    }

  // Binding specific methods 
  public:
    ior_t *_get_ior() {return d_self;}

    const ior_t *_get_ior() const {return d_self;}

    bool _is_nil() const {return(d_self == 0);}

    bool _not_nil() const {return(d_self != 0);}

    bool operator!() const {return(d_self == 0);}

    static const ext_t *_get_ext() throw ();

  public:
    virtual void *_cast(const char *type) const {
      void *ptr = 0;

      if (d_self != 0) {
        ptr = reinterpret_cast< void * >((*d_self->d_epv->f__cast_ior)(d_self->d_object, type));
      }
      return ptr;
    }

  // User defined methods 
  public:
    void
    SIDL::BaseInterface::addReference()
    throw ()
    ;
    
    void
    SIDL::BaseInterface::deleteReference()
    throw ()
    ;
    
    bool
    SIDL::BaseInterface::isSame(
      /*in*/ ::SIDL::BaseInterface iobj)
    throw ()
    ;
    
    ::SIDL::BaseInterface
    SIDL::BaseInterface::queryInterface(
      /*in*/ std::string name)
    throw ()
    ;
    
    bool
    SIDL::BaseInterface::isInstanceOf(
      /*in*/ std::string name)
    throw ()
    ;
    
  }; // end class BaseInterface
} // end namespace SIDL

// Array specialization
namespace SIDL {
  template <>
  class array< ::SIDL::BaseInterface > : public array_mixin<struct SIDL_BaseInterface__array, struct SIDL_BaseInterface__object *, ::SIDL::BaseInterface> {
  public:
    // Default constructor
    array() : array_mixin<struct SIDL_BaseInterface__array, struct SIDL_BaseInterface__object *, ::SIDL::BaseInterface>() {}

    // Constructor/Casting operator
    array(struct SIDL_BaseInterface__array *src) : array_mixin<struct SIDL_BaseInterface__array, struct SIDL_BaseInterface__object *, ::SIDL::BaseInterface>(src) {}
  };
}

#endif /*included_SIDL_BaseInterface_stub*/
