#ifndef included_SIDL_DLL_stub
#include "SIDL/DLL/DLL.hh"
#endif

bool
SIDL::DLL::loadLibrary(
  /*in*/ std::string uri)
throw ()
{
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_uri = NULL;
  if (uri.c_str()) {
    _local_uri = (char *) malloc(strlen(uri.c_str())+1);
    strcpy(_local_uri, uri.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_loadLibrary))(d_self, /*in*/ _local_uri);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_uri) {::free((void *) _local_uri);}
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

std::string
SIDL::DLL::getLibraryName()
throw ()
{
  // Return value setup
  std::string _result;
  char * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getLibraryName))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = _local__result;
  if (_local__result) {::free((void *) _local__result);}
  return _result;
}

void
SIDL::DLL::unloadLibrary()
throw ()
{
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_unloadLibrary))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void*
SIDL::DLL::lookupSymbol(
  /*in*/ std::string linker_name)
throw ()
{
  // Return value setup
  void* _result;
  // Pack arguments for dispatch to IOR
  char *_local_linker_name = NULL;
  if (linker_name.c_str()) {
    _local_linker_name = (char *) malloc(strlen(linker_name.c_str())+1);
    strcpy(_local_linker_name, linker_name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _result = (*(d_self->d_epv->f_lookupSymbol))(d_self, /*in*/ _local_linker_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_linker_name) {::free((void *) _local_linker_name);}
  // Return value cleanup
  return _result;
}

::SIDL::BaseClass
SIDL::DLL::createClass(
  /*in*/ std::string sidl_name)
throw ()
{
  // Return value setup
  ::SIDL::BaseClass _result;
  struct SIDL_BaseClass__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_sidl_name = NULL;
  if (sidl_name.c_str()) {
    _local_sidl_name = (char *) malloc(strlen(sidl_name.c_str())+1);
    strcpy(_local_sidl_name, sidl_name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_createClass))(d_self, /*in*/ _local_sidl_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_sidl_name) {::free((void *) _local_sidl_name);}
  // Return value cleanup
  _result = ::SIDL::BaseClass(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

void
SIDL::DLL::addReference()
throw ()
{
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_addReference))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDL::DLL::deleteReference()
throw ()
{
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_deleteReference))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
SIDL::DLL::isSame(
  /*in*/ ::SIDL::BaseInterface iobj)
throw ()
{
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isSame))(d_self, /*in*/ iobj._get_ior());
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

::SIDL::BaseInterface
SIDL::DLL::queryInterface(
  /*in*/ std::string name)
throw ()
{
  // Return value setup
  ::SIDL::BaseInterface _result;
  struct SIDL_BaseInterface__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_queryInterface))(d_self, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = ::SIDL::BaseInterface(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

bool
SIDL::DLL::isInstanceOf(
  /*in*/ std::string name)
throw ()
{
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isInstanceOf))(d_self, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

const ::SIDL::DLL::ext_t *::SIDL::DLL::s_ext;

const ::SIDL::DLL::ext_t *::SIDL::DLL::_get_ext() throw () {
  if (!s_ext) {
    s_ext = SIDL_DLL__externals();
  }
  return s_ext;
}

