// Get rid of this crap
#include "sidl_config.h"

#ifndef included_SIDL_cxx_hh
#include "SIDL_cxx.hh"
#endif

#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif

// Forward declaration
namespace SIDL {
  // Symbol "SIDL.Loader"
  class Loader;
} // end namespace SIDL

// Array specialization
namespace SIDL {
  template<>
  class array< ::SIDL::Loader >;
} // end namespace SIDL

#ifndef included_SIDL_Loader_stub
#define included_SIDL_Loader_stub

//
// Includes for all method dependencies
//
#ifndef included_SIDL_DLL_stub
#include "SIDL/DLL/DLL.hh"
#endif
#ifndef included_SIDL_BaseClass_stub
#include "SIDL/BaseClass/BaseClass.hh"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface/BaseInterface.hh"
#endif

namespace SIDL {
  // Symbol "SIDL.Loader"
  class Loader : public ::SIDL::StubBase {

  // Type definitions 
  public:
    typedef struct SIDL_Loader__object ior_t;
    typedef struct SIDL_Loader__external ext_t;
    typedef struct SIDL_Loader__sepv sepv_t;

  private:
    // Pointer to IOR
    ior_t *d_self;

    // Weak references which do not add/deleteRef() (used by Impl)
    bool d_weak_reference;

    // Pointer to function table (DLL loadable symbols) which is shared among instances
    static const ext_t *s_ext;

  // Static constructor
  public:
    static ::SIDL::Loader _create() {
      ::SIDL::Loader self((*_get_ext()->createObject)());
      // The reference count is now 2
      //   1 from createObject()
      //   1 from IOR to C++ conversion
      // Decrement this count back down to one
      self.deleteReference();
      return self;
    }

  // Constructors/Destructors 
  public:
    // Default constructor
    Loader() : d_self(0), d_weak_reference(false) {}

    // Default destructor
    virtual ~Loader() {
      if (d_self != 0) {
        deleteReference();
      }
    }

    // Copy constructor
    Loader(const Loader& original) {
      d_self = const_cast< ior_t * >(original.d_self);
      d_weak_reference = original.d_weak_reference;
      if (d_self != 0) {
        addReference();
      }
    }

    // Assignment operator
    Loader& operator=(const Loader& rhs) {
      if (d_self != rhs.d_self) {
        if (d_self != 0) {
          deleteReference();
        }
        d_self = const_cast< ior_t * >(rhs.d_self);
        d_weak_reference = rhs.d_weak_reference;
        if (d_self != 0) {
          addReference();
        }
      }
      return *this;
    }

  // Casting Operators 
  public:
    // Conversion from IOR to C++ class
    Loader(Loader::ior_t *ior) : d_self(ior), d_weak_reference(false) {
      if (d_self != 0) {
        addReference();
      }
    }

    // Alternate constructor which does not call addReference()
    //   also sets d_weak_reference = isWeak
    //   used by Impl (fixes bug #275)
    Loader(Loader::ior_t *ior, bool isWeak) : d_self(ior), d_weak_reference(isWeak) {}

    // Conversion from a StubBase
    Loader(const ::SIDL::StubBase& base) {
      d_self = reinterpret_cast< ior_t * >(base._cast("SIDL.Loader"));
      d_weak_reference = false;
      if (d_self != 0) {
        addReference();
      }
    }

  // Binding specific methods 
  public:
    ior_t *_get_ior() {return d_self;}

    const ior_t *_get_ior() const {return d_self;}

    bool _is_nil() const {return(d_self == 0);}

    bool _not_nil() const {return(d_self != 0);}

    bool operator!() const {return(d_self == 0);}

    static const ext_t *_get_ext() throw ();

    static const sepv_t *_get_sepv() throw () {
      return (*(_get_ext()->getStaticEPV))();
    }

  public:
    virtual void *_cast(const char *type) const {
      void *ptr = 0;

      if (d_self != 0) {
        ptr = reinterpret_cast< void * >((*d_self->d_epv->f__cast_ior)(d_self, type));
      }
      return ptr;
    }

  // User defined methods 
  public:
    static void
    SIDL::Loader::setSearchPath(
      /*in*/ std::string path_name)
    throw ()
    ;
    
    static std::string
    SIDL::Loader::getSearchPath()
    throw ()
    ;
    
    static void
    SIDL::Loader::addSearchPath(
      /*in*/ std::string path_fragment)
    throw ()
    ;
    
    static bool
    SIDL::Loader::loadLibrary(
      /*in*/ std::string uri)
    throw ()
    ;
    
    static void
    SIDL::Loader::addDLL(
      /*in*/ ::SIDL::DLL dll)
    throw ()
    ;
    
    static void
    SIDL::Loader::unloadLibraries()
    throw ()
    ;
    
    static void*
    SIDL::Loader::lookupSymbol(
      /*in*/ std::string linker_name)
    throw ()
    ;
    
    static ::SIDL::BaseClass
    SIDL::Loader::createClass(
      /*in*/ std::string sidl_name)
    throw ()
    ;
    
    void
    SIDL::Loader::addReference()
    throw ()
    ;
    
    void
    SIDL::Loader::deleteReference()
    throw ()
    ;
    
    bool
    SIDL::Loader::isSame(
      /*in*/ ::SIDL::BaseInterface iobj)
    throw ()
    ;
    
    ::SIDL::BaseInterface
    SIDL::Loader::queryInterface(
      /*in*/ std::string name)
    throw ()
    ;
    
    bool
    SIDL::Loader::isInstanceOf(
      /*in*/ std::string name)
    throw ()
    ;
    
  }; // end class Loader
} // end namespace SIDL

// Array specialization
namespace SIDL {
  template <>
  class array< ::SIDL::Loader > : public array_mixin<struct SIDL_Loader__array, struct SIDL_Loader__object *, ::SIDL::Loader> {
  public:
    // Default constructor
    array() : array_mixin<struct SIDL_Loader__array, struct SIDL_Loader__object *, ::SIDL::Loader>() {}

    // Constructor/Casting operator
    array(struct SIDL_Loader__array *src) : array_mixin<struct SIDL_Loader__array, struct SIDL_Loader__object *, ::SIDL::Loader>(src) {}
  };
}

#endif /*included_SIDL_Loader_stub*/
