// Get rid of this crap
#include "sidl_config.h"

#ifndef included_SIDL_cxx_hh
#include "SIDL_cxx.hh"
#endif

#ifndef included_SIDL_ProjectState_IOR
#include "SIDL/ProjectState_IOR/ProjectState_IOR.h"
#endif

// Forward declaration
namespace SIDL {
  // Symbol "SIDL.ProjectState"
  class ProjectState;
} // end namespace SIDL

// Array specialization
namespace SIDL {
  template<>
  class array< ::SIDL::ProjectState >;
} // end namespace SIDL

#ifndef included_SIDL_ProjectState_stub
#define included_SIDL_ProjectState_stub

//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_stub
#include "SIDL/Loader/Loader.hh"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException/NullIORException.hh"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException/BaseException.hh"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface/BaseInterface.hh"
#endif

namespace SIDL {
  // Symbol "SIDL.ProjectState"
  class ProjectState : public ::SIDL::StubBase {

  // Type definitions 
  public:
    typedef struct SIDL_ProjectState__object ior_t;
    typedef struct SIDL_ProjectState__external ext_t;

  private:
    // Pointer to IOR
    ior_t *d_self;

    // Weak references which do not add/deleteRef() (used by Impl)
    bool d_weak_reference;

    // Pointer to function table (DLL loadable symbols) which is shared among instances
    static const ext_t *s_ext;

  // Constructors/Destructors 
  public:
    // Default constructor
    ProjectState() : d_self(0), d_weak_reference(false) {}

    // Default destructor
    virtual ~ProjectState() {
      if (d_self != 0) {
        deleteReference();
      }
    }

    // Copy constructor
    ProjectState(const ProjectState& original) {
      d_self = const_cast< ior_t * >(original.d_self);
      d_weak_reference = original.d_weak_reference;
      if (d_self != 0) {
        addReference();
      }
    }

    // Assignment operator
    ProjectState& operator=(const ProjectState& rhs) {
      if (d_self != rhs.d_self) {
        if (d_self != 0) {
          deleteReference();
        }
        d_self = const_cast< ior_t * >(rhs.d_self);
        d_weak_reference = rhs.d_weak_reference;
        if (d_self != 0) {
          addReference();
        }
      }
      return *this;
    }

  // Casting Operators 
  public:
    // Conversion from IOR to C++ class
    ProjectState(ProjectState::ior_t *ior) : d_self(ior), d_weak_reference(false) {
      if (d_self != 0) {
        addReference();
      }
    }

    // Alternate constructor which does not call addReference()
    //   also sets d_weak_reference = isWeak
    //   used by Impl (fixes bug #275)
    ProjectState(ProjectState::ior_t *ior, bool isWeak) : d_self(ior), d_weak_reference(isWeak) {}

    // Conversion from a StubBase
    ProjectState(const ::SIDL::StubBase& base) {
      d_self = reinterpret_cast< ior_t * >(base._cast("SIDL.ProjectState"));
      d_weak_reference = false;
      if (d_self != 0) {
        addReference();
      }
    }

  // Binding specific methods 
  public:
    ior_t *_get_ior() {return d_self;}

    const ior_t *_get_ior() const {return d_self;}

    bool _is_nil() const {return(d_self == 0);}

    bool _not_nil() const {return(d_self != 0);}

    bool operator!() const {return(d_self == 0);}

    static const ext_t *_get_ext() throw (::SIDL::NullIORException);

  public:
    virtual void *_cast(const char *type) const {
      void *ptr = 0;

      if (d_self != 0) {
        ptr = reinterpret_cast< void * >((*d_self->d_epv->f__cast_ior)(d_self->d_object, type));
      }
      return ptr;
    }

  // User defined methods 
  public:
    void
    SIDL::ProjectState::Initialize()
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDL::ProjectState::Finalize()
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    bool
    SIDL::ProjectState::Initialized()
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    bool
    SIDL::ProjectState::Finalized()
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDL::ProjectState::addReference()
    throw (
      ::SIDL::NullIORException)
    ;
    
    void
    SIDL::ProjectState::deleteReference()
    throw (
      ::SIDL::NullIORException)
    ;
    
    bool
    SIDL::ProjectState::isSame(
      /*in*/ ::SIDL::BaseInterface iobj)
    throw (
      ::SIDL::NullIORException)
    ;
    
    ::SIDL::BaseInterface
    SIDL::ProjectState::queryInterface(
      /*in*/ std::string name)
    throw (
      ::SIDL::NullIORException)
    ;
    
    bool
    SIDL::ProjectState::isInstanceOf(
      /*in*/ std::string name)
    throw (
      ::SIDL::NullIORException)
    ;
    
  }; // end class ProjectState
} // end namespace SIDL

// Array specialization
namespace SIDL {
  template <>
  class array< ::SIDL::ProjectState > : public array_mixin<struct SIDL_ProjectState__array, struct SIDL_ProjectState__object *, ::SIDL::ProjectState> {
  public:
    // Default constructor
    array() : array_mixin<struct SIDL_ProjectState__array, struct SIDL_ProjectState__object *, ::SIDL::ProjectState>() {}

    // Constructor/Casting operator
    array(struct SIDL_ProjectState__array *src) : array_mixin<struct SIDL_ProjectState__array, struct SIDL_ProjectState__object *, ::SIDL::ProjectState>(src) {}
  };
}

#endif /*included_SIDL_ProjectState_stub*/
