#define SIDL_Args_INTERNAL 1

#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#include "Numeric/arrayobject.h"

#ifndef included_SIDL_Args_stub
#include "SIDL/Args_Module.h"
#endif
#ifndef included_SIDL_Args_IOR
#include "SIDL/Args_IOR/Args_IOR.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException_Module.h"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif


static const struct SIDL_Args__sepv * _sepv = NULL;
static const struct SIDL_Args__external * _epv = NULL;

static PyObject *
SIDL_Args_set(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_string__array * args = NULL;
  static char *_kwlist[] = {
    (char *) "args",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDL_string__borrow_python_array, &args
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for set");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Dispatch to IOR */
  (_sepv->f_set)(  /*in*/ args, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDL_string__array_destroy(args);
  return _return_value;
}

static PyObject *
SIDL_Args_get(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_string__array * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for get");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Dispatch to IOR */
  _result = (_sepv->f_get)(  &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_string__python_clone_array, _result
  );
  SIDL_string__array_destroy(_result);
  return _return_value;
}

static PyObject *
SIDL_Args_addReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_Args__object *_self_ior = ((struct SIDL_Args__object *) SIDL_Cast(_self, "SIDL.Args"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_Args_deleteReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_Args__object *_self_ior = ((struct SIDL_Args__object *) SIDL_Cast(_self, "SIDL.Args"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for deleteReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in deleteReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_deleteReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_Args_isSame(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_Args__object *_self_ior = ((struct SIDL_Args__object *) SIDL_Cast(_self, "SIDL.Args"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_BaseInterface__object * iobj = NULL;
  static char *_kwlist[] = {
    (char *) "iobj",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDL_BaseInterface__convert, &iobj
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isSame");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isSame()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isSame))(_self_ior  , /*in*/ iobj);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  SIDL_BaseInterface__deref(iobj);
  return _return_value;
}

static PyObject *
SIDL_Args_queryInterface(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_Args__object *_self_ior = ((struct SIDL_Args__object *) SIDL_Cast(_self, "SIDL.Args"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseInterface__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for queryInterface");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in queryInterface()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_queryInterface))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_BaseInterface__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDL_Args_isInstanceOf(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_Args__object *_self_ior = ((struct SIDL_Args__object *) SIDL_Cast(_self, "SIDL.Args"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isInstanceOf");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isInstanceOf()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isInstanceOf))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDL_Args_Args(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_Args__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_Args__object * optarg = NULL;
  static char *_kwlist[] = {
    (char *) "optarg",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "|O&", _kwlist,
    (void *) SIDL_Args__convert, &optarg
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for Args");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Implementation code */
  if (optarg) {
    (*(optarg->d_epv->f_addReference))(optarg);
  } else {
    optarg = (*(_epv->createObject))();
  }
  /* Since we may merely up the reference count and return the argument, add an extra reference */
  SIDL_Args__addRef(optarg);
  _result = optarg;  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_Args__wrap, _result
  );
  SIDL_Args__deref(optarg);
  return _return_value;
}

static PyMethodDef _ArgsModuleMethods[] = {
  {(char *) "Args", (PyCFunction) SIDL_Args_Args, (METH_VARARGS | METH_KEYWORDS), (char *) "Args(in Args optarg)\n\
RETURNS\n\
  SIDL.Args _result\n\
Constructor and/or cast method for SIDL.Args\n\
"},
  {(char *) "set", (PyCFunction) SIDL_Args_set, (METH_VARARGS | METH_KEYWORDS), (char *) "set(in array args)\n\
RETURNS\n\
   None\n\
// Set the command line arguments (removes any that are currently there)\n\
"},
  {(char *) "get", (PyCFunction) SIDL_Args_get, (METH_VARARGS | METH_KEYWORDS), (char *) "get()\n\
RETURNS\n\
  array _result\n\
// Returns the command line arguments\n\
"},
  {NULL, NULL}
};

static PyMethodDef _ArgsObjectMethods[] = {
  {(char *) "addReference", (PyCFunction) SIDL_Args_addReference, (METH_VARARGS | METH_KEYWORDS), (char *) "addReference()\n\
RETURNS\n\
   None\n\
// Add one to the intrinsic reference count in the underlying object.\n\
// Object in <code>SIDL</code> have an intrinsic reference count.\n\
// Objects continue to exist as long as the reference count is\n\
// positive. Clients should call this method whenever they\n\
// create another ongoing reference to an object or interface.\n\
// \n\
// This does not have a return value because there is no language\n\
// independent type that can refer to an interface or a\n\
// class.\n\
"},
  {(char *) "deleteReference", (PyCFunction) SIDL_Args_deleteReference, (METH_VARARGS | METH_KEYWORDS), (char *) "deleteReference()\n\
RETURNS\n\
   None\n\
// Decrease by one the intrinsic reference count in the underlying\n\
// object, and delete the object if the reference is non-positive.\n\
// Objects in <code>SIDL</code> have an intrinsic reference count.\n\
// Clients should call this method whenever they remove a\n\
// reference to an object or interface.\n\
"},
  {(char *) "isSame", (PyCFunction) SIDL_Args_isSame, (METH_VARARGS | METH_KEYWORDS), (char *) "isSame(in BaseInterface iobj)\n\
RETURNS\n\
  bool _result\n\
// Return true if and only if <code>obj</code> refers to the same\n\
// object as this object.\n\
"},
  {(char *) "queryInterface", (PyCFunction) SIDL_Args_queryInterface, (METH_VARARGS | METH_KEYWORDS), (char *) "queryInterface(in string name)\n\
RETURNS\n\
  SIDL.BaseInterface _result\n\
// Check whether the object can support the specified interface or\n\
// class.  If the <code>SIDL</code> type name in <code>name</code>\n\
// is supported, then a reference to that object is returned with the\n\
// reference count incremented.  The callee will be responsible for\n\
// calling <code>deleteReference</code> on the returned object.  If\n\
// the specified type is not supported, then a null reference is\n\
// returned.\n\
"},
  {(char *) "isInstanceOf", (PyCFunction) SIDL_Args_isInstanceOf, (METH_VARARGS | METH_KEYWORDS), (char *) "isInstanceOf(in string name)\n\
RETURNS\n\
  bool _result\n\
// Return whether this object is an instance of the specified type.\n\
// The string name must be the <code>SIDL</code> type name.  This\n\
// routine will return <code>true</code> if and only if a cast to\n\
// the string type name would succeed.\n\
"},
  {NULL, NULL}
};

SIDL_Args__wrap_RETURN
SIDL_Args__wrap SIDL_Args__wrap_PROTO {
  if (!sidlobj) {
    return Py_None;
  } else {
    return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "SIDL.Args"), _ArgsObjectMethods, SIDL_PyStealRef);
  }
}

SIDL_Args__weakRef_RETURN
SIDL_Args__weakRef SIDL_Args__weakRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "SIDL.Args"), _ArgsObjectMethods, SIDL_PyWeakRef);
}

SIDL_Args__deref_RETURN
SIDL_Args__deref SIDL_Args__deref_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_deleteReference))(sidlobj);
  }
}

SIDL_Args__newRef_RETURN
SIDL_Args__newRef SIDL_Args__newRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "SIDL.Args"), _ArgsObjectMethods, SIDL_PyNewRef);
}

SIDL_Args__addRef_RETURN
SIDL_Args__addRef SIDL_Args__addRef_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_addReference))(sidlobj);
  }
}

SIDL_Args__convert_RETURN
SIDL_Args__convert SIDL_Args__convert_PROTO {
  *sidlobj = SIDL_Cast(obj, "SIDL.Args");
  if (*sidlobj) {
    (*((*sidlobj)->d_epv->f_addReference))((*sidlobj));
  } else if (obj != Py_None) {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type SIDL.Args");
    return 0;
  }
  return 1;
}

static int
_convertPython(void *sidlarray, const int *ind, PyObject *pyobj) {
  struct SIDL_Args__object *sidlobj;

  if (SIDL_Args__convert(pyobj, &sidlobj)) {
    (*_epv->setElement)((struct SIDL_Args__array *) sidlarray, ind, sidlobj);
    return 0;
  }
  return 1;
}

SIDL_Args__convert_python_array_RETURN
SIDL_Args__convert_python_array SIDL_Args__convert_python_array_PROTO {
  PyObject *pya    = PyArray_FromObject(obj, PyArray_OBJECT, 0, 0);
  int       result = 0;

  *sidlarray = NULL;
  if (pya) {
    if (PyArray_OBJECT == ((PyArrayObject *) pya)->descr->type_num) {
      int dimen, *lower, *upper, *stride;

      if (SIDL_array__extract_python_info(pya, &dimen, &lower, &upper, &stride)) {
        *sidlarray = (*_epv->createArray)(dimen, lower, upper);
        free(lower);
        free(upper);
        free(stride);
        result = SIDL_array__convert_python(pya, dimen, *sidlarray, _convertPython);
        if (*sidlarray && !result) {
          (*_epv->destroyArray)(*sidlarray);
          *sidlarray = NULL;
        }
      }
    }
    Py_DECREF(pya);
  }
  return result;
}

static int
_convertSIDL(void *sidlarray, const int *ind, PyObject **dest) {
  struct SIDL_Args__object *sidlobj = (*_epv->getElement)((struct SIDL_Args__array *) sidlarray, ind);

  *dest = SIDL_Args__wrap(sidlobj);
  return (*dest == NULL);
}

SIDL_Args__convert_sidl_array_RETURN
SIDL_Args__convert_sidl_array SIDL_Args__convert_sidl_array_PROTO {
  PyObject *pya = NULL;

  if (sidlarray) {
    const int dimen   = (*_epv->getDimen)(sidlarray);
    int      *lower   = (int *) malloc(dimen * sizeof(int));
    int      *upper   = (int *) malloc(dimen * sizeof(int));
    int      *numElem = (int *) malloc(dimen * sizeof(int));
    int       i;

    for(i = 0; i < dimen; i++) {
      lower[i]   = (*_epv->getLower)(sidlarray, i);
      upper[i]   = (*_epv->getUpper)(sidlarray, i);
      numElem[i] = upper[i] - lower[i] + 1;
    }
    pya = PyArray_FromDims(dimen, numElem, PyArray_OBJECT);;
    if (pya) {
      if (!SIDL_array__convert_sidl(pya, dimen, lower, upper, numElem, sidlarray, _convertSIDL)) {
        Py_DECREF(pya);
        pya = NULL;
      }
    }
    free(lower);
    free(upper);
    free(numElem);
  }
  return pya;
}

SIDL_Args__destroy_sidl_array_RETURN
SIDL_Args__destroy_sidl_array SIDL_Args__destroy_sidl_array_PROTO {
  if (sidlarray) {
    (*_epv->destroyArray)(sidlarray);
  }
}

void initArgs(void) {
  PyObject *module, *dict, *c_api;
  static void *ExternalAPI[SIDL_Args__API_NUM];
  struct SIDL_Args__external * (*_extFunc)(void) = NULL;
  module = Py_InitModule3((char *) "Args", _ArgsModuleMethods, (char *) "// Handles command line arguments and related issues\n\
");
  _extFunc = (struct SIDL_Args__external * (*)(void)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("SIDL_Args__externals");
  if (_extFunc) {
    _epv = (*_extFunc)();
  }
  if (!_epv) {
    PyErr_SetString(PyExc_TypeError, "Cannot load SIDL implementation for SIDL.Args");
    return;
  }
  dict = PyModule_GetDict(module);
  ExternalAPI[SIDL_Args__wrap_NUM] = SIDL_Args__wrap;
  ExternalAPI[SIDL_Args__convert_NUM] = SIDL_Args__convert;
  ExternalAPI[SIDL_Args__convert_python_array_NUM] = SIDL_Args__convert_python_array;
  ExternalAPI[SIDL_Args__convert_sidl_array_NUM] = SIDL_Args__convert_sidl_array;
  ExternalAPI[SIDL_Args__destroy_sidl_array_NUM] = SIDL_Args__destroy_sidl_array;
  ExternalAPI[SIDL_Args__weakRef_NUM] = SIDL_Args__weakRef;
  ExternalAPI[SIDL_Args__deref_NUM] = SIDL_Args__deref;
  ExternalAPI[SIDL_Args__newRef_NUM] = SIDL_Args__newRef;
  ExternalAPI[SIDL_Args__addRef_NUM] = SIDL_Args__addRef;
  import_SIDLObjA();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLObjA module");
    return;
  }
  c_api = PyCObject_FromVoidPtr((void *) ExternalAPI, NULL);
  PyDict_SetItemString(dict, (char *) "_C_API", c_api);
  Py_XDECREF(c_api);
  _sepv = (*_epv->getStaticEPV)();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_TypeError, "Cannot initialize Python module SIDL.Args");
    return;
  }
  import_SIDLPyArrays();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLPyArrays module");
    return;
  }
  import_array();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import Numeric Python array module");
    return;
  }
  SIDL_BaseException__import();
  SIDL_NullIORException__import();
  SIDL_BaseInterface__import();
}
