#define SIDL_DLL_INTERNAL 1

#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#include "Numeric/arrayobject.h"

#ifndef included_SIDL_DLL_stub
#include "SIDL/DLL_Module.h"
#endif
#ifndef included_SIDL_DLL_IOR
#include "SIDL/DLL_IOR/DLL_IOR.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDL_BaseClass_stub
#include "SIDL/BaseClass_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif


static const struct SIDL_DLL__external * _epv = NULL;

static PyObject *
SIDL_DLL_loadLibrary(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_DLL__object *_self_ior = ((struct SIDL_DLL__object *) SIDL_Cast(_self, "SIDL.DLL"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  char * uri;
  static char *_kwlist[] = {
    (char *) "uri",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &uri
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for loadLibrary");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in loadLibrary()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_loadLibrary))(_self_ior  , /*in*/ uri);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDL_DLL_getLibraryName(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_DLL__object *_self_ior = ((struct SIDL_DLL__object *) SIDL_Cast(_self, "SIDL.DLL"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  char * _result;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getLibraryName");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getLibraryName()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getLibraryName))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "z",
    _result
  );
  free((void *) _result);
  return _return_value;
}

static PyObject *
SIDL_DLL_unloadLibrary(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_DLL__object *_self_ior = ((struct SIDL_DLL__object *) SIDL_Cast(_self, "SIDL.DLL"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for unloadLibrary");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in unloadLibrary()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_unloadLibrary))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_DLL_lookupSymbol(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_DLL__object *_self_ior = ((struct SIDL_DLL__object *) SIDL_Cast(_self, "SIDL.DLL"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  void * _result;
  /* Pack arguments for dispatch to IOR */
  char * linker_name;
  static char *_kwlist[] = {
    (char *) "linker_name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &linker_name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for lookupSymbol");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in lookupSymbol()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_lookupSymbol))(_self_ior  , /*in*/ linker_name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_Opaque_Create, _result
  );
  return _return_value;
}

static PyObject *
SIDL_DLL_createClass(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_DLL__object *_self_ior = ((struct SIDL_DLL__object *) SIDL_Cast(_self, "SIDL.DLL"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseClass__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  char * sidl_name;
  static char *_kwlist[] = {
    (char *) "sidl_name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &sidl_name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for createClass");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in createClass()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_createClass))(_self_ior  , /*in*/ sidl_name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_BaseClass__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDL_DLL_addReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_DLL__object *_self_ior = ((struct SIDL_DLL__object *) SIDL_Cast(_self, "SIDL.DLL"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_DLL_deleteReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_DLL__object *_self_ior = ((struct SIDL_DLL__object *) SIDL_Cast(_self, "SIDL.DLL"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for deleteReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in deleteReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_deleteReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_DLL_isSame(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_DLL__object *_self_ior = ((struct SIDL_DLL__object *) SIDL_Cast(_self, "SIDL.DLL"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_BaseInterface__object * iobj = NULL;
  static char *_kwlist[] = {
    (char *) "iobj",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDL_BaseInterface__convert, &iobj
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isSame");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isSame()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isSame))(_self_ior  , /*in*/ iobj);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  SIDL_BaseInterface__deref(iobj);
  return _return_value;
}

static PyObject *
SIDL_DLL_queryInterface(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_DLL__object *_self_ior = ((struct SIDL_DLL__object *) SIDL_Cast(_self, "SIDL.DLL"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseInterface__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for queryInterface");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in queryInterface()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_queryInterface))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_BaseInterface__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDL_DLL_isInstanceOf(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_DLL__object *_self_ior = ((struct SIDL_DLL__object *) SIDL_Cast(_self, "SIDL.DLL"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isInstanceOf");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isInstanceOf()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isInstanceOf))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDL_DLL_DLL(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_DLL__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_DLL__object * optarg = NULL;
  static char *_kwlist[] = {
    (char *) "optarg",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "|O&", _kwlist,
    (void *) SIDL_DLL__convert, &optarg
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for DLL");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Implementation code */
  if (optarg) {
    (*(optarg->d_epv->f_addReference))(optarg);
  } else {
    optarg = (*(_epv->createObject))();
  }
  /* Since we may merely up the reference count and return the argument, add an extra reference */
  SIDL_DLL__addRef(optarg);
  _result = optarg;  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_DLL__wrap, _result
  );
  SIDL_DLL__deref(optarg);
  return _return_value;
}

static PyMethodDef _DLLModuleMethods[] = {
  {(char *) "DLL", (PyCFunction) SIDL_DLL_DLL, (METH_VARARGS | METH_KEYWORDS), (char *) "DLL(in DLL optarg)\n\
RETURNS\n\
  SIDL.DLL _result\n\
Constructor and/or cast method for SIDL.DLL\n\
"},
  {NULL, NULL}
};

static PyMethodDef _DLLObjectMethods[] = {
  {(char *) "loadLibrary", (PyCFunction) SIDL_DLL_loadLibrary, (METH_VARARGS | METH_KEYWORDS), (char *) "loadLibrary(in string uri)\n\
RETURNS\n\
  bool _result\n\
// Load a dynamic link library using the specified URI.  The\n\
// URI may be of the form \"main:\", \"lib:\", \"file:\", \"ftp:\", or\n\
// \"http:\".  A URI that starts with any other protocol string\n\
// is assumed to be a file name.  The \"main:\" URI creates a\n\
// library that allows access to global symbols in the running\n\
// program\'s main address space.  The \"lib:X\" URI converts the\n\
// library \"X\" into a platform-specific name (e.g., libX.so) and\n\
// loads that library.  The \"file:\" URI opens the DLL from the\n\
// specified file path.  The \"ftp:\" and \"http:\" URIs copy the\n\
// specified library from the remote site into a local temporary\n\
// file and open that file.  This method returns true if the\n\
// DLL was loaded successfully and false otherwise.  Note that\n\
// the \"ftp:\" and \"http:\" protocols are valid only if the W3C\n\
// WWW library is available.\n\
"},
  {(char *) "getLibraryName", (PyCFunction) SIDL_DLL_getLibraryName, (METH_VARARGS | METH_KEYWORDS), (char *) "getLibraryName()\n\
RETURNS\n\
  string _result\n\
// Get the library name.  This is the name used to load the\n\
// library in <code>loadLibrary</code> except that all file names\n\
// contain the \"file:\" protocol.\n\
"},
  {(char *) "unloadLibrary", (PyCFunction) SIDL_DLL_unloadLibrary, (METH_VARARGS | METH_KEYWORDS), (char *) "unloadLibrary()\n\
RETURNS\n\
   None\n\
// Unload the dynamic link library.  The library may no longer\n\
// be used to access symbol names.  When the library is actually\n\
// unloaded from the memory image depends on details of the operating\n\
// system.\n\
"},
  {(char *) "lookupSymbol", (PyCFunction) SIDL_DLL_lookupSymbol, (METH_VARARGS | METH_KEYWORDS), (char *) "lookupSymbol(in string linker_name)\n\
RETURNS\n\
  opaque _result\n\
// Lookup a symbol from the DLL and return the associated pointer.\n\
// A null value is returned if the name does not exist.\n\
"},
  {(char *) "createClass", (PyCFunction) SIDL_DLL_createClass, (METH_VARARGS | METH_KEYWORDS), (char *) "createClass(in string sidl_name)\n\
RETURNS\n\
  SIDL.BaseClass _result\n\
// Create an instance of the SIDL class.  If the class constructor\n\
// is not defined in this DLL, then return null.\n\
"},
  {(char *) "addReference", (PyCFunction) SIDL_DLL_addReference, (METH_VARARGS | METH_KEYWORDS), (char *) "addReference()\n\
RETURNS\n\
   None\n\
// Add one to the intrinsic reference count in the underlying object.\n\
// Object in <code>SIDL</code> have an intrinsic reference count.\n\
// Objects continue to exist as long as the reference count is\n\
// positive. Clients should call this method whenever they\n\
// create another ongoing reference to an object or interface.\n\
// \n\
// This does not have a return value because there is no language\n\
// independent type that can refer to an interface or a\n\
// class.\n\
"},
  {(char *) "deleteReference", (PyCFunction) SIDL_DLL_deleteReference, (METH_VARARGS | METH_KEYWORDS), (char *) "deleteReference()\n\
RETURNS\n\
   None\n\
// Decrease by one the intrinsic reference count in the underlying\n\
// object, and delete the object if the reference is non-positive.\n\
// Objects in <code>SIDL</code> have an intrinsic reference count.\n\
// Clients should call this method whenever they remove a\n\
// reference to an object or interface.\n\
"},
  {(char *) "isSame", (PyCFunction) SIDL_DLL_isSame, (METH_VARARGS | METH_KEYWORDS), (char *) "isSame(in BaseInterface iobj)\n\
RETURNS\n\
  bool _result\n\
// Return true if and only if <code>obj</code> refers to the same\n\
// object as this object.\n\
"},
  {(char *) "queryInterface", (PyCFunction) SIDL_DLL_queryInterface, (METH_VARARGS | METH_KEYWORDS), (char *) "queryInterface(in string name)\n\
RETURNS\n\
  SIDL.BaseInterface _result\n\
// Check whether the object can support the specified interface or\n\
// class.  If the <code>SIDL</code> type name in <code>name</code>\n\
// is supported, then a reference to that object is returned with the\n\
// reference count incremented.  The callee will be responsible for\n\
// calling <code>deleteReference</code> on the returned object.  If\n\
// the specified type is not supported, then a null reference is\n\
// returned.\n\
"},
  {(char *) "isInstanceOf", (PyCFunction) SIDL_DLL_isInstanceOf, (METH_VARARGS | METH_KEYWORDS), (char *) "isInstanceOf(in string name)\n\
RETURNS\n\
  bool _result\n\
// Return whether this object is an instance of the specified type.\n\
// The string name must be the <code>SIDL</code> type name.  This\n\
// routine will return <code>true</code> if and only if a cast to\n\
// the string type name would succeed.\n\
"},
  {NULL, NULL}
};

SIDL_DLL__wrap_RETURN
SIDL_DLL__wrap SIDL_DLL__wrap_PROTO {
  if (!sidlobj) {
    return Py_None;
  } else {
    return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "SIDL.DLL"), _DLLObjectMethods, SIDL_PyStealRef);
  }
}

SIDL_DLL__weakRef_RETURN
SIDL_DLL__weakRef SIDL_DLL__weakRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "SIDL.DLL"), _DLLObjectMethods, SIDL_PyWeakRef);
}

SIDL_DLL__deref_RETURN
SIDL_DLL__deref SIDL_DLL__deref_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_deleteReference))(sidlobj);
  }
}

SIDL_DLL__newRef_RETURN
SIDL_DLL__newRef SIDL_DLL__newRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "SIDL.DLL"), _DLLObjectMethods, SIDL_PyNewRef);
}

SIDL_DLL__addRef_RETURN
SIDL_DLL__addRef SIDL_DLL__addRef_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_addReference))(sidlobj);
  }
}

SIDL_DLL__convert_RETURN
SIDL_DLL__convert SIDL_DLL__convert_PROTO {
  *sidlobj = SIDL_Cast(obj, "SIDL.DLL");
  if (*sidlobj) {
    (*((*sidlobj)->d_epv->f_addReference))((*sidlobj));
  } else if (obj != Py_None) {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type SIDL.DLL");
    return 0;
  }
  return 1;
}

static int
_convertPython(void *sidlarray, const int *ind, PyObject *pyobj) {
  struct SIDL_DLL__object *sidlobj;

  if (SIDL_DLL__convert(pyobj, &sidlobj)) {
    (*_epv->setElement)((struct SIDL_DLL__array *) sidlarray, ind, sidlobj);
    return 0;
  }
  return 1;
}

SIDL_DLL__convert_python_array_RETURN
SIDL_DLL__convert_python_array SIDL_DLL__convert_python_array_PROTO {
  PyObject *pya    = PyArray_FromObject(obj, PyArray_OBJECT, 0, 0);
  int       result = 0;

  *sidlarray = NULL;
  if (pya) {
    if (PyArray_OBJECT == ((PyArrayObject *) pya)->descr->type_num) {
      int dimen, *lower, *upper, *stride;

      if (SIDL_array__extract_python_info(pya, &dimen, &lower, &upper, &stride)) {
        *sidlarray = (*_epv->createArray)(dimen, lower, upper);
        free(lower);
        free(upper);
        free(stride);
        result = SIDL_array__convert_python(pya, dimen, *sidlarray, _convertPython);
        if (*sidlarray && !result) {
          (*_epv->destroyArray)(*sidlarray);
          *sidlarray = NULL;
        }
      }
    }
    Py_DECREF(pya);
  }
  return result;
}

static int
_convertSIDL(void *sidlarray, const int *ind, PyObject **dest) {
  struct SIDL_DLL__object *sidlobj = (*_epv->getElement)((struct SIDL_DLL__array *) sidlarray, ind);

  *dest = SIDL_DLL__wrap(sidlobj);
  return (*dest == NULL);
}

SIDL_DLL__convert_sidl_array_RETURN
SIDL_DLL__convert_sidl_array SIDL_DLL__convert_sidl_array_PROTO {
  PyObject *pya = NULL;

  if (sidlarray) {
    const int dimen   = (*_epv->getDimen)(sidlarray);
    int      *lower   = (int *) malloc(dimen * sizeof(int));
    int      *upper   = (int *) malloc(dimen * sizeof(int));
    int      *numElem = (int *) malloc(dimen * sizeof(int));
    int       i;

    for(i = 0; i < dimen; i++) {
      lower[i]   = (*_epv->getLower)(sidlarray, i);
      upper[i]   = (*_epv->getUpper)(sidlarray, i);
      numElem[i] = upper[i] - lower[i] + 1;
    }
    pya = PyArray_FromDims(dimen, numElem, PyArray_OBJECT);;
    if (pya) {
      if (!SIDL_array__convert_sidl(pya, dimen, lower, upper, numElem, sidlarray, _convertSIDL)) {
        Py_DECREF(pya);
        pya = NULL;
      }
    }
    free(lower);
    free(upper);
    free(numElem);
  }
  return pya;
}

SIDL_DLL__destroy_sidl_array_RETURN
SIDL_DLL__destroy_sidl_array SIDL_DLL__destroy_sidl_array_PROTO {
  if (sidlarray) {
    (*_epv->destroyArray)(sidlarray);
  }
}

void initDLL(void) {
  PyObject *module, *dict, *c_api;
  static void *ExternalAPI[SIDL_DLL__API_NUM];
  module = Py_InitModule3((char *) "DLL", _DLLModuleMethods, (char *) "// The <code>DLL</code> class encapsulates access to a single\n\
// dynamically linked library.  DLLs are loaded at run-time using\n\
// the <code>loadLibrary</code> method and later unloaded using\n\
// <code>unloadLibrary</code>.  Symbols in a loaded library are\n\
// resolved to an opaque pointer by method <code>lookupSymbol</code>.\n\
// Class instances are created by <code>createClass</code>.\n\
");
  _epv = SIDL_DLL__externals();
  if (!_epv) {
    PyErr_SetString(PyExc_TypeError, "Cannot load SIDL implementation for SIDL.DLL");
    return;
  }
  dict = PyModule_GetDict(module);
  ExternalAPI[SIDL_DLL__wrap_NUM] = SIDL_DLL__wrap;
  ExternalAPI[SIDL_DLL__convert_NUM] = SIDL_DLL__convert;
  ExternalAPI[SIDL_DLL__convert_python_array_NUM] = SIDL_DLL__convert_python_array;
  ExternalAPI[SIDL_DLL__convert_sidl_array_NUM] = SIDL_DLL__convert_sidl_array;
  ExternalAPI[SIDL_DLL__destroy_sidl_array_NUM] = SIDL_DLL__destroy_sidl_array;
  ExternalAPI[SIDL_DLL__weakRef_NUM] = SIDL_DLL__weakRef;
  ExternalAPI[SIDL_DLL__deref_NUM] = SIDL_DLL__deref;
  ExternalAPI[SIDL_DLL__newRef_NUM] = SIDL_DLL__newRef;
  ExternalAPI[SIDL_DLL__addRef_NUM] = SIDL_DLL__addRef;
  import_SIDLObjA();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLObjA module");
    return;
  }
  c_api = PyCObject_FromVoidPtr((void *) ExternalAPI, NULL);
  PyDict_SetItemString(dict, (char *) "_C_API", c_api);
  Py_XDECREF(c_api);
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_TypeError, "Cannot initialize Python module SIDL.DLL");
    return;
  }
  import_SIDLPyArrays();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLPyArrays module");
    return;
  }
  import_array();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import Numeric Python array module");
    return;
  }
  SIDL_BaseClass__import();
  SIDL_BaseInterface__import();
}
