#define SIDL_Loader_INTERNAL 1

#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#include "Numeric/arrayobject.h"

#ifndef included_SIDL_Loader_stub
#include "SIDL/Loader_Module.h"
#endif
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_DLL_stub
#include "SIDL/DLL_Module.h"
#endif
#ifndef included_SIDL_BaseClass_stub
#include "SIDL/BaseClass_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif


static const struct SIDL_Loader__sepv * _sepv = NULL;
static const struct SIDL_Loader__external * _epv = NULL;

static PyObject *
SIDL_Loader_setSearchPath(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  char * path_name;
  static char *_kwlist[] = {
    (char *) "path_name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &path_name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setSearchPath");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Dispatch to IOR */
  (_sepv->f_setSearchPath)(  /*in*/ path_name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_Loader_getSearchPath(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  char * _result;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getSearchPath");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Dispatch to IOR */
  _result = (_sepv->f_getSearchPath)(  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "z",
    _result
  );
  free((void *) _result);
  return _return_value;
}

static PyObject *
SIDL_Loader_addSearchPath(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  char * path_fragment;
  static char *_kwlist[] = {
    (char *) "path_fragment",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &path_fragment
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addSearchPath");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Dispatch to IOR */
  (_sepv->f_addSearchPath)(  /*in*/ path_fragment);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_Loader_loadLibrary(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  char * uri;
  static char *_kwlist[] = {
    (char *) "uri",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &uri
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for loadLibrary");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Dispatch to IOR */
  _result = (_sepv->f_loadLibrary)(  /*in*/ uri);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDL_Loader_addDLL(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_DLL__object * dll = NULL;
  static char *_kwlist[] = {
    (char *) "dll",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDL_DLL__convert, &dll
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addDLL");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Dispatch to IOR */
  (_sepv->f_addDLL)(  /*in*/ dll);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDL_DLL__deref(dll);
  return _return_value;
}

static PyObject *
SIDL_Loader_unloadLibraries(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for unloadLibraries");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Dispatch to IOR */
  (_sepv->f_unloadLibraries)(  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_Loader_lookupSymbol(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  void * _result;
  /* Pack arguments for dispatch to IOR */
  char * linker_name;
  static char *_kwlist[] = {
    (char *) "linker_name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &linker_name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for lookupSymbol");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Dispatch to IOR */
  _result = (_sepv->f_lookupSymbol)(  /*in*/ linker_name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_Opaque_Create, _result
  );
  return _return_value;
}

static PyObject *
SIDL_Loader_createClass(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseClass__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  char * sidl_name;
  static char *_kwlist[] = {
    (char *) "sidl_name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &sidl_name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for createClass");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Dispatch to IOR */
  _result = (_sepv->f_createClass)(  /*in*/ sidl_name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_BaseClass__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDL_Loader_addReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_Loader__object *_self_ior = ((struct SIDL_Loader__object *) SIDL_Cast(_self, "SIDL.Loader"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_Loader_deleteReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_Loader__object *_self_ior = ((struct SIDL_Loader__object *) SIDL_Cast(_self, "SIDL.Loader"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for deleteReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in deleteReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_deleteReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_Loader_isSame(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_Loader__object *_self_ior = ((struct SIDL_Loader__object *) SIDL_Cast(_self, "SIDL.Loader"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_BaseInterface__object * iobj = NULL;
  static char *_kwlist[] = {
    (char *) "iobj",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDL_BaseInterface__convert, &iobj
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isSame");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isSame()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isSame))(_self_ior  , /*in*/ iobj);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  SIDL_BaseInterface__deref(iobj);
  return _return_value;
}

static PyObject *
SIDL_Loader_queryInterface(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_Loader__object *_self_ior = ((struct SIDL_Loader__object *) SIDL_Cast(_self, "SIDL.Loader"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseInterface__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for queryInterface");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in queryInterface()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_queryInterface))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_BaseInterface__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDL_Loader_isInstanceOf(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_Loader__object *_self_ior = ((struct SIDL_Loader__object *) SIDL_Cast(_self, "SIDL.Loader"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isInstanceOf");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isInstanceOf()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isInstanceOf))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDL_Loader_Loader(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_Loader__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_Loader__object * optarg = NULL;
  static char *_kwlist[] = {
    (char *) "optarg",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "|O&", _kwlist,
    (void *) SIDL_Loader__convert, &optarg
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for Loader");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Implementation code */
  if (optarg) {
    (*(optarg->d_epv->f_addReference))(optarg);
  } else {
    optarg = (*(_epv->createObject))();
  }
  /* Since we may merely up the reference count and return the argument, add an extra reference */
  SIDL_Loader__addRef(optarg);
  _result = optarg;  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_Loader__wrap, _result
  );
  SIDL_Loader__deref(optarg);
  return _return_value;
}

static PyMethodDef _LoaderModuleMethods[] = {
  {(char *) "Loader", (PyCFunction) SIDL_Loader_Loader, (METH_VARARGS | METH_KEYWORDS), (char *) "Loader(in Loader optarg)\n\
RETURNS\n\
  SIDL.Loader _result\n\
Constructor and/or cast method for SIDL.Loader\n\
"},
  {(char *) "setSearchPath", (PyCFunction) SIDL_Loader_setSearchPath, (METH_VARARGS | METH_KEYWORDS), (char *) "setSearchPath(in string path_name)\n\
RETURNS\n\
   None\n\
// Set the search path, which is a semi-colon separated sequence of\n\
// URIs as described in class <code>DLL</code>.  This method will\n\
// invalidate any existing search path.\n\
"},
  {(char *) "getSearchPath", (PyCFunction) SIDL_Loader_getSearchPath, (METH_VARARGS | METH_KEYWORDS), (char *) "getSearchPath()\n\
RETURNS\n\
  string _result\n\
// Return the current search path.  If the search path has not been\n\
// set, then the search path will be taken from environment variable\n\
// SIDL_DLL_PATH.\n\
"},
  {(char *) "addSearchPath", (PyCFunction) SIDL_Loader_addSearchPath, (METH_VARARGS | METH_KEYWORDS), (char *) "addSearchPath(in string path_fragment)\n\
RETURNS\n\
   None\n\
// Append the specified path fragment to the beginning of the\n\
// current search path.  If the search path has not yet been set\n\
// by a call to <code>setSearchPath</code>, then this fragment will\n\
// be appended to the path in environment variable SIDL_DLL_PATH.\n\
"},
  {(char *) "loadLibrary", (PyCFunction) SIDL_Loader_loadLibrary, (METH_VARARGS | METH_KEYWORDS), (char *) "loadLibrary(in string uri)\n\
RETURNS\n\
  bool _result\n\
// Load the specified library if it has not already been loaded.\n\
// The URI format is defined in class <code>DLL</code>.  The search\n\
// path is not searched to resolve the library name.\n\
"},
  {(char *) "addDLL", (PyCFunction) SIDL_Loader_addDLL, (METH_VARARGS | METH_KEYWORDS), (char *) "addDLL(in DLL dll)\n\
RETURNS\n\
   None\n\
// Append the specified DLL to the beginning of the list of already\n\
// loaded DLLs.\n\
"},
  {(char *) "unloadLibraries", (PyCFunction) SIDL_Loader_unloadLibraries, (METH_VARARGS | METH_KEYWORDS), (char *) "unloadLibraries()\n\
RETURNS\n\
   None\n\
// Unload all dynamic link libraries.  The library may no longer\n\
// be used to access symbol names.  When the library is actually\n\
// unloaded from the memory image depends on details of the operating\n\
// system.\n\
"},
  {(char *) "lookupSymbol", (PyCFunction) SIDL_Loader_lookupSymbol, (METH_VARARGS | METH_KEYWORDS), (char *) "lookupSymbol(in string linker_name)\n\
RETURNS\n\
  opaque _result\n\
// Look up the secified symbol name.  If the symbol name cannot be\n\
// found in one of the already loaded libraries, then the method will\n\
// search through the library search path.  A null is returned if the\n\
// symbol could not be resolved.\n\
"},
  {(char *) "createClass", (PyCFunction) SIDL_Loader_createClass, (METH_VARARGS | METH_KEYWORDS), (char *) "createClass(in string sidl_name)\n\
RETURNS\n\
  SIDL.BaseClass _result\n\
// Create an instance of the specified SIDL class.  If the class\n\
// constructor cannot be found in one of the already loaded libraries,\n\
// then the method will search through the library search path.  A null\n\
// object is returned if the symbol could not be resolved.\n\
"},
  {NULL, NULL}
};

static PyMethodDef _LoaderObjectMethods[] = {
  {(char *) "addReference", (PyCFunction) SIDL_Loader_addReference, (METH_VARARGS | METH_KEYWORDS), (char *) "addReference()\n\
RETURNS\n\
   None\n\
// Add one to the intrinsic reference count in the underlying object.\n\
// Object in <code>SIDL</code> have an intrinsic reference count.\n\
// Objects continue to exist as long as the reference count is\n\
// positive. Clients should call this method whenever they\n\
// create another ongoing reference to an object or interface.\n\
// \n\
// This does not have a return value because there is no language\n\
// independent type that can refer to an interface or a\n\
// class.\n\
"},
  {(char *) "deleteReference", (PyCFunction) SIDL_Loader_deleteReference, (METH_VARARGS | METH_KEYWORDS), (char *) "deleteReference()\n\
RETURNS\n\
   None\n\
// Decrease by one the intrinsic reference count in the underlying\n\
// object, and delete the object if the reference is non-positive.\n\
// Objects in <code>SIDL</code> have an intrinsic reference count.\n\
// Clients should call this method whenever they remove a\n\
// reference to an object or interface.\n\
"},
  {(char *) "isSame", (PyCFunction) SIDL_Loader_isSame, (METH_VARARGS | METH_KEYWORDS), (char *) "isSame(in BaseInterface iobj)\n\
RETURNS\n\
  bool _result\n\
// Return true if and only if <code>obj</code> refers to the same\n\
// object as this object.\n\
"},
  {(char *) "queryInterface", (PyCFunction) SIDL_Loader_queryInterface, (METH_VARARGS | METH_KEYWORDS), (char *) "queryInterface(in string name)\n\
RETURNS\n\
  SIDL.BaseInterface _result\n\
// Check whether the object can support the specified interface or\n\
// class.  If the <code>SIDL</code> type name in <code>name</code>\n\
// is supported, then a reference to that object is returned with the\n\
// reference count incremented.  The callee will be responsible for\n\
// calling <code>deleteReference</code> on the returned object.  If\n\
// the specified type is not supported, then a null reference is\n\
// returned.\n\
"},
  {(char *) "isInstanceOf", (PyCFunction) SIDL_Loader_isInstanceOf, (METH_VARARGS | METH_KEYWORDS), (char *) "isInstanceOf(in string name)\n\
RETURNS\n\
  bool _result\n\
// Return whether this object is an instance of the specified type.\n\
// The string name must be the <code>SIDL</code> type name.  This\n\
// routine will return <code>true</code> if and only if a cast to\n\
// the string type name would succeed.\n\
"},
  {NULL, NULL}
};

SIDL_Loader__wrap_RETURN
SIDL_Loader__wrap SIDL_Loader__wrap_PROTO {
  if (!sidlobj) {
    return Py_None;
  } else {
    return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "SIDL.Loader"), _LoaderObjectMethods, SIDL_PyStealRef);
  }
}

SIDL_Loader__weakRef_RETURN
SIDL_Loader__weakRef SIDL_Loader__weakRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "SIDL.Loader"), _LoaderObjectMethods, SIDL_PyWeakRef);
}

SIDL_Loader__deref_RETURN
SIDL_Loader__deref SIDL_Loader__deref_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_deleteReference))(sidlobj);
  }
}

SIDL_Loader__newRef_RETURN
SIDL_Loader__newRef SIDL_Loader__newRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "SIDL.Loader"), _LoaderObjectMethods, SIDL_PyNewRef);
}

SIDL_Loader__addRef_RETURN
SIDL_Loader__addRef SIDL_Loader__addRef_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_addReference))(sidlobj);
  }
}

SIDL_Loader__convert_RETURN
SIDL_Loader__convert SIDL_Loader__convert_PROTO {
  *sidlobj = SIDL_Cast(obj, "SIDL.Loader");
  if (*sidlobj) {
    (*((*sidlobj)->d_epv->f_addReference))((*sidlobj));
  } else if (obj != Py_None) {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type SIDL.Loader");
    return 0;
  }
  return 1;
}

static int
_convertPython(void *sidlarray, const int *ind, PyObject *pyobj) {
  struct SIDL_Loader__object *sidlobj;

  if (SIDL_Loader__convert(pyobj, &sidlobj)) {
    (*_epv->setElement)((struct SIDL_Loader__array *) sidlarray, ind, sidlobj);
    return 0;
  }
  return 1;
}

SIDL_Loader__convert_python_array_RETURN
SIDL_Loader__convert_python_array SIDL_Loader__convert_python_array_PROTO {
  PyObject *pya    = PyArray_FromObject(obj, PyArray_OBJECT, 0, 0);
  int       result = 0;

  *sidlarray = NULL;
  if (pya) {
    if (PyArray_OBJECT == ((PyArrayObject *) pya)->descr->type_num) {
      int dimen, *lower, *upper, *stride;

      if (SIDL_array__extract_python_info(pya, &dimen, &lower, &upper, &stride)) {
        *sidlarray = (*_epv->createArray)(dimen, lower, upper);
        free(lower);
        free(upper);
        free(stride);
        result = SIDL_array__convert_python(pya, dimen, *sidlarray, _convertPython);
        if (*sidlarray && !result) {
          (*_epv->destroyArray)(*sidlarray);
          *sidlarray = NULL;
        }
      }
    }
    Py_DECREF(pya);
  }
  return result;
}

static int
_convertSIDL(void *sidlarray, const int *ind, PyObject **dest) {
  struct SIDL_Loader__object *sidlobj = (*_epv->getElement)((struct SIDL_Loader__array *) sidlarray, ind);

  *dest = SIDL_Loader__wrap(sidlobj);
  return (*dest == NULL);
}

SIDL_Loader__convert_sidl_array_RETURN
SIDL_Loader__convert_sidl_array SIDL_Loader__convert_sidl_array_PROTO {
  PyObject *pya = NULL;

  if (sidlarray) {
    const int dimen   = (*_epv->getDimen)(sidlarray);
    int      *lower   = (int *) malloc(dimen * sizeof(int));
    int      *upper   = (int *) malloc(dimen * sizeof(int));
    int      *numElem = (int *) malloc(dimen * sizeof(int));
    int       i;

    for(i = 0; i < dimen; i++) {
      lower[i]   = (*_epv->getLower)(sidlarray, i);
      upper[i]   = (*_epv->getUpper)(sidlarray, i);
      numElem[i] = upper[i] - lower[i] + 1;
    }
    pya = PyArray_FromDims(dimen, numElem, PyArray_OBJECT);;
    if (pya) {
      if (!SIDL_array__convert_sidl(pya, dimen, lower, upper, numElem, sidlarray, _convertSIDL)) {
        Py_DECREF(pya);
        pya = NULL;
      }
    }
    free(lower);
    free(upper);
    free(numElem);
  }
  return pya;
}

SIDL_Loader__destroy_sidl_array_RETURN
SIDL_Loader__destroy_sidl_array SIDL_Loader__destroy_sidl_array_PROTO {
  if (sidlarray) {
    (*_epv->destroyArray)(sidlarray);
  }
}

void initLoader(void) {
  PyObject *module, *dict, *c_api;
  static void *ExternalAPI[SIDL_Loader__API_NUM];
  module = Py_InitModule3((char *) "Loader", _LoaderModuleMethods, (char *) "// Class <code>Loader</code> manages dyanamic loading and symbol name\n\
// resolution for the SIDL runtime system.  The <code>Loader</code> class\n\
// manages a library search path and keeps a record of all libraries\n\
// loaded through this interface, including the initial \"global\" symbols\n\
// in the main program.  Unless explicitly set, the search path is taken\n\
// from the environment variable SIDL_DLL_PATH, which is a semi-colon\n\
// separated sequence of URIs as described in class <code>DLL</code>.\n\
");
  _epv = SIDL_Loader__externals();
  if (!_epv) {
    PyErr_SetString(PyExc_TypeError, "Cannot load SIDL implementation for SIDL.Loader");
    return;
  }
  dict = PyModule_GetDict(module);
  ExternalAPI[SIDL_Loader__wrap_NUM] = SIDL_Loader__wrap;
  ExternalAPI[SIDL_Loader__convert_NUM] = SIDL_Loader__convert;
  ExternalAPI[SIDL_Loader__convert_python_array_NUM] = SIDL_Loader__convert_python_array;
  ExternalAPI[SIDL_Loader__convert_sidl_array_NUM] = SIDL_Loader__convert_sidl_array;
  ExternalAPI[SIDL_Loader__destroy_sidl_array_NUM] = SIDL_Loader__destroy_sidl_array;
  ExternalAPI[SIDL_Loader__weakRef_NUM] = SIDL_Loader__weakRef;
  ExternalAPI[SIDL_Loader__deref_NUM] = SIDL_Loader__deref;
  ExternalAPI[SIDL_Loader__newRef_NUM] = SIDL_Loader__newRef;
  ExternalAPI[SIDL_Loader__addRef_NUM] = SIDL_Loader__addRef;
  import_SIDLObjA();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLObjA module");
    return;
  }
  c_api = PyCObject_FromVoidPtr((void *) ExternalAPI, NULL);
  PyDict_SetItemString(dict, (char *) "_C_API", c_api);
  Py_XDECREF(c_api);
  _sepv = (*_epv->getStaticEPV)();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_TypeError, "Cannot initialize Python module SIDL.Loader");
    return;
  }
  import_SIDLPyArrays();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLPyArrays module");
    return;
  }
  import_array();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import Numeric Python array module");
    return;
  }
  SIDL_DLL__import();
  SIDL_BaseClass__import();
  SIDL_BaseInterface__import();
}
