#define SIDL_NullIORException_INTERNAL 1

#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#include "Numeric/arrayobject.h"

#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_NullIORException_IOR
#include "SIDL/NullIORException_IOR/NullIORException_IOR.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif


static const struct SIDL_NullIORException__external * _epv = NULL;

static PyObject *
SIDL_NullIORException_getMessage(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_NullIORException__object *_self_ior = ((struct SIDL_NullIORException__object *) SIDL_Cast(_self, "SIDL.NullIORException"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  char * _result;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getMessage");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getMessage()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getMessage))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "z",
    _result
  );
  free((void *) _result);
  return _return_value;
}

static PyObject *
SIDL_NullIORException_setMessage(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_NullIORException__object *_self_ior = ((struct SIDL_NullIORException__object *) SIDL_Cast(_self, "SIDL.NullIORException"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  char * message;
  static char *_kwlist[] = {
    (char *) "message",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &message
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setMessage");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setMessage()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setMessage))(_self_ior  , /*in*/ message);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_NullIORException_getStackTrace(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_NullIORException__object *_self_ior = ((struct SIDL_NullIORException__object *) SIDL_Cast(_self, "SIDL.NullIORException"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  char * _result;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getStackTrace");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getStackTrace()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getStackTrace))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "z",
    _result
  );
  free((void *) _result);
  return _return_value;
}

static PyObject *
SIDL_NullIORException_addToStackTrace(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_NullIORException__object *_self_ior = ((struct SIDL_NullIORException__object *) SIDL_Cast(_self, "SIDL.NullIORException"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  char * traceline;
  static char *_kwlist[] = {
    (char *) "traceline",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &traceline
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addToStackTrace");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addToStackTrace()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addToStackTrace))(_self_ior  , /*in*/ traceline);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_NullIORException_addToTrace(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_NullIORException__object *_self_ior = ((struct SIDL_NullIORException__object *) SIDL_Cast(_self, "SIDL.NullIORException"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  char * filename;
  int32_t lineno;
  int _local_lineno;
  char * methodname;
  static char *_kwlist[] = {
    (char *) "filename",
    (char *) "lineno",
    (char *) "methodname",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "zlz", _kwlist,
    &filename,
    &_local_lineno,
    &methodname
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addToTrace");
    return _return_value;
  }
  lineno = _local_lineno;
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addToTrace()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addToTrace))(_self_ior  , /*in*/ filename, /*in*/ lineno, /*in*/ methodname);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_NullIORException_addReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_NullIORException__object *_self_ior = ((struct SIDL_NullIORException__object *) SIDL_Cast(_self, "SIDL.NullIORException"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_NullIORException_deleteReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_NullIORException__object *_self_ior = ((struct SIDL_NullIORException__object *) SIDL_Cast(_self, "SIDL.NullIORException"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for deleteReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in deleteReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_deleteReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDL_NullIORException_isSame(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_NullIORException__object *_self_ior = ((struct SIDL_NullIORException__object *) SIDL_Cast(_self, "SIDL.NullIORException"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_BaseInterface__object * iobj = NULL;
  static char *_kwlist[] = {
    (char *) "iobj",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDL_BaseInterface__convert, &iobj
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isSame");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isSame()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isSame))(_self_ior  , /*in*/ iobj);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  SIDL_BaseInterface__deref(iobj);
  return _return_value;
}

static PyObject *
SIDL_NullIORException_queryInterface(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_NullIORException__object *_self_ior = ((struct SIDL_NullIORException__object *) SIDL_Cast(_self, "SIDL.NullIORException"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseInterface__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for queryInterface");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in queryInterface()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_queryInterface))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_BaseInterface__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDL_NullIORException_isInstanceOf(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDL_NullIORException__object *_self_ior = ((struct SIDL_NullIORException__object *) SIDL_Cast(_self, "SIDL.NullIORException"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isInstanceOf");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isInstanceOf()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isInstanceOf))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDL_NullIORException_NullIORException(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_NullIORException__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_NullIORException__object * optarg = NULL;
  static char *_kwlist[] = {
    (char *) "optarg",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "|O&", _kwlist,
    (void *) SIDL_NullIORException__convert, &optarg
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for NullIORException");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Implementation code */
  if (optarg) {
    (*(optarg->d_epv->f_addReference))(optarg);
  } else {
    optarg = (*(_epv->createObject))();
  }
  /* Since we may merely up the reference count and return the argument, add an extra reference */
  SIDL_NullIORException__addRef(optarg);
  _result = optarg;  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_NullIORException__wrap, _result
  );
  SIDL_NullIORException__deref(optarg);
  return _return_value;
}

static PyMethodDef _NullIORExceptionModuleMethods[] = {
  {(char *) "NullIORException", (PyCFunction) SIDL_NullIORException_NullIORException, (METH_VARARGS | METH_KEYWORDS), (char *) "NullIORException(in NullIORException optarg)\n\
RETURNS\n\
  SIDL.NullIORException _result\n\
Constructor and/or cast method for SIDL.NullIORException\n\
"},
  {NULL, NULL}
};

static PyMethodDef _NullIORExceptionObjectMethods[] = {
  {(char *) "getMessage", (PyCFunction) SIDL_NullIORException_getMessage, (METH_VARARGS | METH_KEYWORDS), (char *) "getMessage()\n\
RETURNS\n\
  string _result\n\
// Return the message associated with the exception.\n\
"},
  {(char *) "setMessage", (PyCFunction) SIDL_NullIORException_setMessage, (METH_VARARGS | METH_KEYWORDS), (char *) "setMessage(in string message)\n\
RETURNS\n\
   None\n\
// Set the message associated with the exception.\n\
"},
  {(char *) "getStackTrace", (PyCFunction) SIDL_NullIORException_getStackTrace, (METH_VARARGS | METH_KEYWORDS), (char *) "getStackTrace()\n\
RETURNS\n\
  string _result\n\
// Returns formatted string containing the concatenation of all \n\
// tracelines.\n\
"},
  {(char *) "addToStackTrace", (PyCFunction) SIDL_NullIORException_addToStackTrace, (METH_VARARGS | METH_KEYWORDS), (char *) "addToStackTrace(in string traceline)\n\
RETURNS\n\
   None\n\
// Adds a stringified entry/line to the stack trace.\n\
"},
  {(char *) "addToTrace", (PyCFunction) SIDL_NullIORException_addToTrace, (METH_VARARGS | METH_KEYWORDS), (char *) "addToTrace(in string filename, in int lineno, in string methodname)\n\
RETURNS\n\
   None\n\
// Formats and adds an entry to the stack trace based on the \n\
// file name, line number, and method name.\n\
"},
  {(char *) "addReference", (PyCFunction) SIDL_NullIORException_addReference, (METH_VARARGS | METH_KEYWORDS), (char *) "addReference()\n\
RETURNS\n\
   None\n\
// Add one to the intrinsic reference count in the underlying object.\n\
// Object in <code>SIDL</code> have an intrinsic reference count.\n\
// Objects continue to exist as long as the reference count is\n\
// positive. Clients should call this method whenever they\n\
// create another ongoing reference to an object or interface.\n\
// \n\
// This does not have a return value because there is no language\n\
// independent type that can refer to an interface or a\n\
// class.\n\
"},
  {(char *) "deleteReference", (PyCFunction) SIDL_NullIORException_deleteReference, (METH_VARARGS | METH_KEYWORDS), (char *) "deleteReference()\n\
RETURNS\n\
   None\n\
// Decrease by one the intrinsic reference count in the underlying\n\
// object, and delete the object if the reference is non-positive.\n\
// Objects in <code>SIDL</code> have an intrinsic reference count.\n\
// Clients should call this method whenever they remove a\n\
// reference to an object or interface.\n\
"},
  {(char *) "isSame", (PyCFunction) SIDL_NullIORException_isSame, (METH_VARARGS | METH_KEYWORDS), (char *) "isSame(in BaseInterface iobj)\n\
RETURNS\n\
  bool _result\n\
// Return true if and only if <code>obj</code> refers to the same\n\
// object as this object.\n\
"},
  {(char *) "queryInterface", (PyCFunction) SIDL_NullIORException_queryInterface, (METH_VARARGS | METH_KEYWORDS), (char *) "queryInterface(in string name)\n\
RETURNS\n\
  SIDL.BaseInterface _result\n\
// Check whether the object can support the specified interface or\n\
// class.  If the <code>SIDL</code> type name in <code>name</code>\n\
// is supported, then a reference to that object is returned with the\n\
// reference count incremented.  The callee will be responsible for\n\
// calling <code>deleteReference</code> on the returned object.  If\n\
// the specified type is not supported, then a null reference is\n\
// returned.\n\
"},
  {(char *) "isInstanceOf", (PyCFunction) SIDL_NullIORException_isInstanceOf, (METH_VARARGS | METH_KEYWORDS), (char *) "isInstanceOf(in string name)\n\
RETURNS\n\
  bool _result\n\
// Return whether this object is an instance of the specified type.\n\
// The string name must be the <code>SIDL</code> type name.  This\n\
// routine will return <code>true</code> if and only if a cast to\n\
// the string type name would succeed.\n\
"},
  {NULL, NULL}
};

SIDL_NullIORException__wrap_RETURN
SIDL_NullIORException__wrap SIDL_NullIORException__wrap_PROTO {
  if (!sidlobj) {
    return Py_None;
  } else {
    return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "SIDL.NullIORException"), _NullIORExceptionObjectMethods, SIDL_PyStealRef);
  }
}

SIDL_NullIORException__weakRef_RETURN
SIDL_NullIORException__weakRef SIDL_NullIORException__weakRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "SIDL.NullIORException"), _NullIORExceptionObjectMethods, SIDL_PyWeakRef);
}

SIDL_NullIORException__deref_RETURN
SIDL_NullIORException__deref SIDL_NullIORException__deref_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_deleteReference))(sidlobj);
  }
}

SIDL_NullIORException__newRef_RETURN
SIDL_NullIORException__newRef SIDL_NullIORException__newRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "SIDL.NullIORException"), _NullIORExceptionObjectMethods, SIDL_PyNewRef);
}

SIDL_NullIORException__addRef_RETURN
SIDL_NullIORException__addRef SIDL_NullIORException__addRef_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_addReference))(sidlobj);
  }
}

SIDL_NullIORException__convert_RETURN
SIDL_NullIORException__convert SIDL_NullIORException__convert_PROTO {
  *sidlobj = SIDL_Cast(obj, "SIDL.NullIORException");
  if (*sidlobj) {
    (*((*sidlobj)->d_epv->f_addReference))((*sidlobj));
  } else if (obj != Py_None) {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type SIDL.NullIORException");
    return 0;
  }
  return 1;
}

static int
_convertPython(void *sidlarray, const int *ind, PyObject *pyobj) {
  struct SIDL_NullIORException__object *sidlobj;

  if (SIDL_NullIORException__convert(pyobj, &sidlobj)) {
    (*_epv->setElement)((struct SIDL_NullIORException__array *) sidlarray, ind, sidlobj);
    return 0;
  }
  return 1;
}

SIDL_NullIORException__convert_python_array_RETURN
SIDL_NullIORException__convert_python_array SIDL_NullIORException__convert_python_array_PROTO {
  PyObject *pya    = PyArray_FromObject(obj, PyArray_OBJECT, 0, 0);
  int       result = 0;

  *sidlarray = NULL;
  if (pya) {
    if (PyArray_OBJECT == ((PyArrayObject *) pya)->descr->type_num) {
      int dimen, *lower, *upper, *stride;

      if (SIDL_array__extract_python_info(pya, &dimen, &lower, &upper, &stride)) {
        *sidlarray = (*_epv->createArray)(dimen, lower, upper);
        free(lower);
        free(upper);
        free(stride);
        result = SIDL_array__convert_python(pya, dimen, *sidlarray, _convertPython);
        if (*sidlarray && !result) {
          (*_epv->destroyArray)(*sidlarray);
          *sidlarray = NULL;
        }
      }
    }
    Py_DECREF(pya);
  }
  return result;
}

static int
_convertSIDL(void *sidlarray, const int *ind, PyObject **dest) {
  struct SIDL_NullIORException__object *sidlobj = (*_epv->getElement)((struct SIDL_NullIORException__array *) sidlarray, ind);

  *dest = SIDL_NullIORException__wrap(sidlobj);
  return (*dest == NULL);
}

SIDL_NullIORException__convert_sidl_array_RETURN
SIDL_NullIORException__convert_sidl_array SIDL_NullIORException__convert_sidl_array_PROTO {
  PyObject *pya = NULL;

  if (sidlarray) {
    const int dimen   = (*_epv->getDimen)(sidlarray);
    int      *lower   = (int *) malloc(dimen * sizeof(int));
    int      *upper   = (int *) malloc(dimen * sizeof(int));
    int      *numElem = (int *) malloc(dimen * sizeof(int));
    int       i;

    for(i = 0; i < dimen; i++) {
      lower[i]   = (*_epv->getLower)(sidlarray, i);
      upper[i]   = (*_epv->getUpper)(sidlarray, i);
      numElem[i] = upper[i] - lower[i] + 1;
    }
    pya = PyArray_FromDims(dimen, numElem, PyArray_OBJECT);;
    if (pya) {
      if (!SIDL_array__convert_sidl(pya, dimen, lower, upper, numElem, sidlarray, _convertSIDL)) {
        Py_DECREF(pya);
        pya = NULL;
      }
    }
    free(lower);
    free(upper);
    free(numElem);
  }
  return pya;
}

SIDL_NullIORException__destroy_sidl_array_RETURN
SIDL_NullIORException__destroy_sidl_array SIDL_NullIORException__destroy_sidl_array_PROTO {
  if (sidlarray) {
    (*_epv->destroyArray)(sidlarray);
  }
}

void initNullIORException(void) {
  PyObject *module, *dict, *c_api;
  static void *ExternalAPI[SIDL_NullIORException__API_NUM];
  module = Py_InitModule((char *) "NullIORException", _NullIORExceptionModuleMethods);
  _epv = SIDL_NullIORException__externals();
  if (!_epv) {
    PyErr_SetString(PyExc_TypeError, "Cannot load SIDL implementation for SIDL.NullIORException");
    return;
  }
  dict = PyModule_GetDict(module);
  ExternalAPI[SIDL_NullIORException__wrap_NUM] = SIDL_NullIORException__wrap;
  ExternalAPI[SIDL_NullIORException__convert_NUM] = SIDL_NullIORException__convert;
  ExternalAPI[SIDL_NullIORException__convert_python_array_NUM] = SIDL_NullIORException__convert_python_array;
  ExternalAPI[SIDL_NullIORException__convert_sidl_array_NUM] = SIDL_NullIORException__convert_sidl_array;
  ExternalAPI[SIDL_NullIORException__destroy_sidl_array_NUM] = SIDL_NullIORException__destroy_sidl_array;
  ExternalAPI[SIDL_NullIORException__weakRef_NUM] = SIDL_NullIORException__weakRef;
  ExternalAPI[SIDL_NullIORException__deref_NUM] = SIDL_NullIORException__deref;
  ExternalAPI[SIDL_NullIORException__newRef_NUM] = SIDL_NullIORException__newRef;
  ExternalAPI[SIDL_NullIORException__addRef_NUM] = SIDL_NullIORException__addRef;
  import_SIDLObjA();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLObjA module");
    return;
  }
  SIDL_NullIORException__type = PyErr_NewException((char *) "SIDL.NullIORException.Exception", SIDL_PyType(), NULL);
  PyDict_SetItemString(dict, (char *) "Exception", SIDL_NullIORException__type);
  ExternalAPI[SIDL_NullIORException__type_NUM] = SIDL_NullIORException__type;
  c_api = PyCObject_FromVoidPtr((void *) ExternalAPI, NULL);
  PyDict_SetItemString(dict, (char *) "_C_API", c_api);
  Py_XDECREF(c_api);
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_TypeError, "Cannot initialize Python module SIDL.NullIORException");
    return;
  }
  import_SIDLPyArrays();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLPyArrays module");
    return;
  }
  import_array();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import Numeric Python array module");
    return;
  }
  SIDL_BaseInterface__import();
}
