#ifndef included_SIDL_Args_impl
#include "SIDL/Args_impl/Args_impl.hh"
#endif

// DO-NOT-DELETE splicer.begin(SIDL.Args.set._includes)
#include <iostream>
// DO-NOT-DELETE splicer.end(SIDL.Args.set._includes)

void
SIDL::Args_impl::set(
  /*in*/ ::SIDL::array< std::string > args)
throw (
  ::SIDL::BaseException)
{
  // DO-NOT-DELETE splicer.begin(SIDL.Args.set)
  int32_t lower, upper;
  if (args.dim() == 0) {
    internalArgs.create(0, &lower, &upper);
  } else {
    if (args.dim() != 1) {
      std::cerr << "Args must be one dimensional array" << std::endl;
      return;
    }
    lower = args.lower(0);
    if (lower != 0) {
      std::cerr << "Args indexing must start at 0" << std::endl;
      return;
    }
    upper = args.upper(0);
    if (internalArgs._not_nil()) {
      internalArgs.destroy();
    }
    internalArgs.create(1, &lower, &upper);
    for(int i = lower; i <= upper; i++) {
      internalArgs.set(args.get(i), i);
    }
  }
  // DO-NOT-DELETE splicer.end(SIDL.Args.set)

}

