#ifndef included_SIDL_cxx_hh
#include "SIDL_cxx.hh"
#endif

#ifndef included_SIDL_BaseClass_IOR
#include "SIDL/BaseClass_IOR/BaseClass_IOR.h"
#endif

#ifndef included_SIDL_BaseClass_impl
#define included_SIDL_BaseClass_impl

//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_stub
#include "SIDL/Loader/Loader.hh"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface/BaseInterface.hh"
#endif
#ifndef included_SIDL_BaseClass_stub
#include "SIDL/BaseClass/BaseClass.hh"
#endif

// DO-NOT-DELETE splicer.begin(SIDL.BaseClass._includes)
// Put additional includes here...
// DO-NOT-DELETE splicer.end(SIDL.BaseClass._includes)

namespace SIDL {
  // Symbol "SIDL.BaseClass"
  class BaseClass_impl {
  private:
    // Pointer back to IOR
    // Use this to dispatch back through IOR vtable
    BaseClass self;

    // DO-NOT-DELETE splicer.begin(SIDL.BaseClass._implementation)
    int refCount; // The instance reference count
    // DO-NOT-DELETE splicer.end(SIDL.BaseClass._implementation)

  // Constructors/Destructors 
  private:
    // private default constructor (required)
    BaseClass_impl() {}

  public:
    // SIDL constructor (required)
    // Note: alternate Skel constructor does not call addref()
    // (fixes bug #275)
    BaseClass_impl(struct SIDL_BaseClass__object *s) : self(s, true) {_ctor();}

    // virtual destructor (required)
    virtual ~BaseClass_impl() {_dtor();}

  // User Constructors/Destructors 
  public:
    void _ctor();
    void _dtor();

  // User defined methods 
  public:
    void
    SIDL::BaseClass_impl::addReference()
    throw ()
    ;
    
    void
    SIDL::BaseClass_impl::deleteReference()
    throw ()
    ;
    
    bool
    SIDL::BaseClass_impl::isSame(
      /*in*/ ::SIDL::BaseInterface iobj)
    throw ()
    ;
    
    ::SIDL::BaseInterface
    SIDL::BaseClass_impl::queryInterface(
      /*in*/ std::string name)
    throw ()
    ;
    
    bool
    SIDL::BaseClass_impl::isInstanceOf(
      /*in*/ std::string name)
    throw ()
    ;
    
  }; // end class BaseClass_impl
} // end namespace SIDL

// DO-NOT-DELETE splicer.begin(SIDL.BaseClass._misc)
// Put miscellaneous things here...
// DO-NOT-DELETE splicer.end(SIDL.BaseClass._misc)

#endif /*included_SIDL_BaseClass_impl*/
