#ifndef included_SIDL_cxx_hh
#include "SIDL_cxx.hh"
#endif

#ifndef included_SIDL_BaseException_IOR
#include "SIDL/BaseException_IOR/BaseException_IOR.h"
#endif

#ifndef included_SIDL_BaseException_impl
#define included_SIDL_BaseException_impl

//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_stub
#include "SIDL/Loader/Loader.hh"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface/BaseInterface.hh"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException/BaseException.hh"
#endif

// DO-NOT-DELETE splicer.begin(SIDL.BaseException._includes)
struct SIDL_BaseException_Trace {
  struct SIDL_BaseException_Trace *next;
  std::string                      line;
};
// DO-NOT-DELETE splicer.end(SIDL.BaseException._includes)

namespace SIDL {
  // Symbol "SIDL.BaseException"
  class BaseException_impl {
  private:
    // Pointer back to IOR
    // Use this to dispatch back through IOR vtable
    BaseException self;

    // DO-NOT-DELETE splicer.begin(SIDL.BaseException._implementation)
    std::string                      message;
    struct SIDL_BaseException_Trace *traceHead;
    struct SIDL_BaseException_Trace *traceTail;
    unsigned long int                traceLength;
    // DO-NOT-DELETE splicer.end(SIDL.BaseException._implementation)

  // Constructors/Destructors 
  private:
    // private default constructor (required)
    BaseException_impl() {}

  public:
    // SIDL constructor (required)
    // Note: alternate Skel constructor does not call addref()
    // (fixes bug #275)
    BaseException_impl(struct SIDL_BaseException__object *s) : self(s, true) {_ctor();}

    // virtual destructor (required)
    virtual ~BaseException_impl() {_dtor();}

  // User Constructors/Destructors 
  public:
    void _ctor();
    void _dtor();

  // User defined methods 
  public:
    std::string
    SIDL::BaseException_impl::getMessage()
    throw ()
    ;
    
    void
    SIDL::BaseException_impl::setMessage(
      /*in*/ std::string message)
    throw ()
    ;
    
    std::string
    SIDL::BaseException_impl::getStackTrace()
    throw ()
    ;
    
    void
    SIDL::BaseException_impl::addToStackTrace(
      /*in*/ std::string traceline)
    throw ()
    ;
    
    void
    SIDL::BaseException_impl::addToTrace(
      /*in*/ std::string filename,
      /*in*/ int32_t lineno,
      /*in*/ std::string methodname)
    throw ()
    ;
    
  }; // end class BaseException_impl
} // end namespace SIDL

// DO-NOT-DELETE splicer.begin(SIDL.BaseException._misc)
// Put miscellaneous things here...
// DO-NOT-DELETE splicer.end(SIDL.BaseException._misc)

#endif /*included_SIDL_BaseException_impl*/
