#ifndef included_SIDL_BaseException_impl
#include "SIDL/BaseException_impl/BaseException_impl.hh"
#endif
#ifndef included_SIDL_BaseException_IOR
#include "SIDL/BaseException_IOR/BaseException_IOR.h"
#endif

extern "C" {

  char *
  SIDL_BaseException_getMessage_skel(
    struct SIDL_BaseException__object *self)
  {
    // Return value setup
    char * _result;
    std::string _local__result;
    // Pack arguments for dispatch to implementation
    // Exception handling setup
    // Get implementation
    ::SIDL::BaseException_impl *_this = reinterpret_cast< ::SIDL::BaseException_impl * >(self->d_data);
    // Dispatch to implementation
    _local__result = _this->getMessage();
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
    _result = NULL;
    if (_local__result.c_str()) {
      _result = (char *) malloc(strlen(_local__result.c_str())+1);
      strcpy(_result, _local__result.c_str());
    }
    return _result;
  }
  
  void
  SIDL_BaseException_setMessage_skel(
    struct SIDL_BaseException__object *self,
    /*in*/ const char * message)
  {
    // Return value setup
    // Pack arguments for dispatch to implementation
    std::string _local_message(message);
    // Exception handling setup
    // Get implementation
    ::SIDL::BaseException_impl *_this = reinterpret_cast< ::SIDL::BaseException_impl * >(self->d_data);
    // Dispatch to implementation
    _this->setMessage(/*in*/ _local_message);
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
  }
  
  char *
  SIDL_BaseException_getStackTrace_skel(
    struct SIDL_BaseException__object *self)
  {
    // Return value setup
    char * _result;
    std::string _local__result;
    // Pack arguments for dispatch to implementation
    // Exception handling setup
    // Get implementation
    ::SIDL::BaseException_impl *_this = reinterpret_cast< ::SIDL::BaseException_impl * >(self->d_data);
    // Dispatch to implementation
    _local__result = _this->getStackTrace();
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
    _result = NULL;
    if (_local__result.c_str()) {
      _result = (char *) malloc(strlen(_local__result.c_str())+1);
      strcpy(_result, _local__result.c_str());
    }
    return _result;
  }
  
  void
  SIDL_BaseException_addToStackTrace_skel(
    struct SIDL_BaseException__object *self,
    /*in*/ const char * traceline)
  {
    // Return value setup
    // Pack arguments for dispatch to implementation
    std::string _local_traceline(traceline);
    // Exception handling setup
    // Get implementation
    ::SIDL::BaseException_impl *_this = reinterpret_cast< ::SIDL::BaseException_impl * >(self->d_data);
    // Dispatch to implementation
    _this->addToStackTrace(/*in*/ _local_traceline);
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
  }
  
  void
  SIDL_BaseException_addToTrace_skel(
    struct SIDL_BaseException__object *self,
    /*in*/ const char * filename,
    /*in*/ int32_t lineno,
    /*in*/ const char * methodname)
  {
    // Return value setup
    // Pack arguments for dispatch to implementation
    std::string _local_filename(filename);
    std::string _local_methodname(methodname);
    // Exception handling setup
    // Get implementation
    ::SIDL::BaseException_impl *_this = reinterpret_cast< ::SIDL::BaseException_impl * >(self->d_data);
    // Dispatch to implementation
    _this->addToTrace(/*in*/ _local_filename, /*in*/ lineno, /*in*/ _local_methodname);
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
  }
  
  void SIDL_BaseException__ctor_skel(struct SIDL_BaseException__object *self) {
    self->d_data = reinterpret_cast< void * >(new ::SIDL::BaseException_impl(self));
  }
  
  void SIDL_BaseException__dtor_skel(struct SIDL_BaseException__object *self) {
    delete(reinterpret_cast< ::SIDL::BaseException_impl * >(self->d_data));
  }
  
  void
  SIDL_BaseException__set_epv(struct SIDL_BaseException__epv * epv) {
    // Initialize constructor and destructor
    epv->f__ctor = SIDL_BaseException__ctor_skel;
    epv->f__dtor = SIDL_BaseException__dtor_skel;
    // Initialize user methods
    epv->f_getMessage = SIDL_BaseException_getMessage_skel;
    epv->f_setMessage = SIDL_BaseException_setMessage_skel;
    epv->f_getStackTrace = SIDL_BaseException_getStackTrace_skel;
    epv->f_addToStackTrace = SIDL_BaseException_addToStackTrace_skel;
    epv->f_addToTrace = SIDL_BaseException_addToTrace_skel;
  }
  
} // end extern "C"

