#ifndef included_SIDL_DLL_impl
#include "SIDL/DLL_impl/DLL_impl.hh"
#endif

// DO-NOT-DELETE splicer.begin(SIDL.DLL.loadLibrary._includes)
#include <iostream>
// DO-NOT-DELETE splicer.end(SIDL.DLL.loadLibrary._includes)

bool
SIDL::DLL_impl::loadLibrary(
  /*in*/ std::string uri)
throw ()
{
  // DO-NOT-DELETE splicer.begin(SIDL.DLL.loadLibrary)
  bool        ok     = false;
#ifdef HAVE_LTDL
  lt_dlhandle handle = NULL;
#else
  void       *handle = NULL;
#endif
  std::string dllfile;
  std::string dllname;

  if (this->libraryHandle) {
    this->unloadLibrary();
  }

  if (uri == "main:") {
    dllname = uri;
  } else if (uri.substr(0, 4) == "lib:") {
    std::string dll = uri.substr(4);

#ifdef HAVE_LTDL
    dllfile  = "lib";
    dllfile += dll;
    dllfile += ".la";
#else
#ifdef __CYGWIN__
    dllfile  = "cyg";
    dllfile += dll;
    dllfile += ".dll";
#else
    dllfile  = "lib";
    dllfile += dll;
    dllfile += ".so";
#endif
#endif
    dllname = uri;
  } else if (uri.substr(0, 5) == "file:") {
    dllfile = uri.substr(5);
    dllname = uri;
#ifdef HAVE_LIBWWW
  } else if (uri.substr(0, 4) == "ftp:") {
    dllfile = this->url_to_local_file(uri);
    dllname = uri;
  } else if (uri.substr(0, 5) == "http:") {
    dllfile = this->url_to_local_file(uri);
    dllname = uri;
#endif
  } else {
    dllfile = uri;
    dllname = "file:"+uri;
  }

#ifdef HAVE_LTDL
  this->check_lt_initialized();
  handle = lt_dlopen(dllfile.c_str());
#else
  handle = dlopen(dllfile.c_str(), RTLD_LAZY | RTLD_LOCAL);
  if (!handle) {
    //SIDL::BaseException e = SIDL::BaseException::_create();
    std::string         msg;

    msg  = "Unable to dlopen() file ";
    msg += dllfile;
    msg += ", error message ";
    msg += dlerror();
    std::cerr << msg << std::endl;
    //e.setMessage(msg);
    //throw e;
  }
#endif

  if (handle) {
    ok = true;
    this->libraryHandle = handle;
    this->libraryName   = dllname;
  } else {
    ok = false;
  }

  return ok;
  // DO-NOT-DELETE splicer.end(SIDL.DLL.loadLibrary)

}

