#ifndef included_SIDL_DLL_impl
#include "SIDL/DLL_impl/DLL_impl.hh"
#endif
#ifndef included_SIDL_DLL_IOR
#include "SIDL/DLL_IOR/DLL_IOR.h"
#endif

extern "C" {

  SIDL_bool
  SIDL_DLL_loadLibrary_skel(
    struct SIDL_DLL__object *self,
    /*in*/ const char * uri)
  {
    // Return value setup
    SIDL_bool _result;
    bool _local__result;
    // Pack arguments for dispatch to implementation
    std::string _local_uri(uri);
    // Exception handling setup
    // Get implementation
    ::SIDL::DLL_impl *_this = reinterpret_cast< ::SIDL::DLL_impl * >(self->d_data);
    // Dispatch to implementation
    _local__result = _this->loadLibrary(/*in*/ _local_uri);
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
    _result = (_local__result ? TRUE : FALSE);
    return _result;
  }
  
  char *
  SIDL_DLL_getLibraryName_skel(
    struct SIDL_DLL__object *self)
  {
    // Return value setup
    char * _result;
    std::string _local__result;
    // Pack arguments for dispatch to implementation
    // Exception handling setup
    // Get implementation
    ::SIDL::DLL_impl *_this = reinterpret_cast< ::SIDL::DLL_impl * >(self->d_data);
    // Dispatch to implementation
    _local__result = _this->getLibraryName();
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
    _result = NULL;
    if (_local__result.c_str()) {
      _result = (char *) malloc(strlen(_local__result.c_str())+1);
      strcpy(_result, _local__result.c_str());
    }
    return _result;
  }
  
  void
  SIDL_DLL_unloadLibrary_skel(
    struct SIDL_DLL__object *self)
  {
    // Return value setup
    // Pack arguments for dispatch to implementation
    // Exception handling setup
    // Get implementation
    ::SIDL::DLL_impl *_this = reinterpret_cast< ::SIDL::DLL_impl * >(self->d_data);
    // Dispatch to implementation
    _this->unloadLibrary();
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
  }
  
  void *
  SIDL_DLL_lookupSymbol_skel(
    struct SIDL_DLL__object *self,
    /*in*/ const char * linker_name)
  {
    // Return value setup
    void * _result;
    // Pack arguments for dispatch to implementation
    std::string _local_linker_name(linker_name);
    // Exception handling setup
    // Get implementation
    ::SIDL::DLL_impl *_this = reinterpret_cast< ::SIDL::DLL_impl * >(self->d_data);
    // Dispatch to implementation
    _result = _this->lookupSymbol(/*in*/ _local_linker_name);
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
    return _result;
  }
  
  struct SIDL_BaseClass__object *
  SIDL_DLL_createClass_skel(
    struct SIDL_DLL__object *self,
    /*in*/ const char * sidl_name)
  {
    // Return value setup
    struct SIDL_BaseClass__object * _result;
    ::SIDL::BaseClass _local__result;
    // Pack arguments for dispatch to implementation
    std::string _local_sidl_name(sidl_name);
    // Exception handling setup
    // Get implementation
    ::SIDL::DLL_impl *_this = reinterpret_cast< ::SIDL::DLL_impl * >(self->d_data);
    // Dispatch to implementation
    _local__result = _this->createClass(/*in*/ _local_sidl_name);
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
    if (_local__result._not_nil()) {
      _local__result.addReference();
    }
    _result = _local__result._get_ior();
    return _result;
  }
  
  void SIDL_DLL__ctor_skel(struct SIDL_DLL__object *self) {
    self->d_data = reinterpret_cast< void * >(new ::SIDL::DLL_impl(self));
  }
  
  void SIDL_DLL__dtor_skel(struct SIDL_DLL__object *self) {
    delete(reinterpret_cast< ::SIDL::DLL_impl * >(self->d_data));
  }
  
  void
  SIDL_DLL__set_epv(struct SIDL_DLL__epv * epv) {
    // Initialize constructor and destructor
    epv->f__ctor = SIDL_DLL__ctor_skel;
    epv->f__dtor = SIDL_DLL__dtor_skel;
    // Initialize user methods
    epv->f_loadLibrary = SIDL_DLL_loadLibrary_skel;
    epv->f_getLibraryName = SIDL_DLL_getLibraryName_skel;
    epv->f_unloadLibrary = SIDL_DLL_unloadLibrary_skel;
    epv->f_lookupSymbol = SIDL_DLL_lookupSymbol_skel;
    epv->f_createClass = SIDL_DLL_createClass_skel;
  }
  
} // end extern "C"

