#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif

/* Static variables for managing EPV initialization */
static int s_method_initialized = 0;
static int s_static_initialized = 0;

static struct SIDL_Loader__epv s_new__sidl_loader;
static struct SIDL_Loader__sepv s_stc__sidl_loader;


static struct SIDL_BaseClass__epv s_new__sidl_baseclass;
static struct SIDL_BaseClass__epv * s_old__sidl_baseclass;

static struct SIDL_BaseInterface__epv s_new__sidl_baseinterface;
static struct SIDL_BaseInterface__epv * s_old__sidl_baseinterface;

/* Declare EPV routines defined in the skeleton */
extern void SIDL_Loader__set_epv(struct SIDL_Loader__epv * epv);
extern void SIDL_Loader__set_sepv(struct SIDL_Loader__sepv * sepv);

/* CAST: dynamic type casting support */
static void *SIDL_Loader__cast_ior(
  struct SIDL_Loader__object *self,
  const char *name)
{
  void *cast = NULL;
  /* We are guaranteed here that the first member in any IOR is a BaseInterface object */
  struct SIDL_Loader__object *s0 = ((struct SIDL_BaseInterface__object *) self)->d_object;
  struct SIDL_BaseClass__object *s1 = &s0->d_sidl_baseclass;

  if (!strcmp(name, "SIDL.Loader")) {
    cast = (void *) s0;
  } else if (!strcmp(name, "SIDL.BaseClass")) {
    cast = (void *) s1;
  } else if (!strcmp(name, "SIDL.BaseInterface")) {
    cast = (void *) &s1->d_sidl_baseinterface;
  }

  return cast;
}

/* DELETE: call destructor and free object memory */
static void SIDL_Loader__delete(
  struct SIDL_Loader__object *self)
{
  struct SIDL_Loader__object * s0 = self->d_epv->f__cast_ior(self, "SIDL.Loader");
  SIDL_Loader__fini(s0);
  memset((void *) s0, 0, sizeof(struct SIDL_Loader__object));
  free((void *) s0);
}

/* INIT_EPV: create method entry point vector (EPV) structure */
static void SIDL_Loader__init_epv(
  struct SIDL_Loader__object *self)
{
  struct SIDL_Loader__object *s0 = self;
  struct SIDL_BaseClass__object *s1 = &s0->d_sidl_baseclass;

  struct SIDL_Loader__epv * epv = &s_new__sidl_loader;
  struct SIDL_BaseClass__epv * e0 = &s_new__sidl_baseclass;
  struct SIDL_BaseInterface__epv * e1 = &s_new__sidl_baseinterface;

  s_old__sidl_baseinterface = s1->d_sidl_baseinterface.d_epv;
  s_old__sidl_baseclass = s1->d_epv;

  epv->f__cast_ior = SIDL_Loader__cast_ior;
  epv->f__delete = SIDL_Loader__delete;
  epv->f__ctor = NULL;
  epv->f__dtor = NULL;
  epv->f_addReference = (void (*)(struct SIDL_Loader__object *)) s1->d_epv->f_addReference;
  epv->f_deleteReference = (void (*)(struct SIDL_Loader__object *)) s1->d_epv->f_deleteReference;
  epv->f_isSame = (SIDL_bool (*)(struct SIDL_Loader__object *, struct SIDL_BaseInterface__object *)) s1->d_epv->f_isSame;
  epv->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(struct SIDL_Loader__object *, const char *)) s1->d_epv->f_queryInterface;
  epv->f_isInstanceOf = (SIDL_bool (*)(struct SIDL_Loader__object *, const char *)) s1->d_epv->f_isInstanceOf;

  SIDL_Loader__set_epv(epv);

  e0->f__cast_ior = (void *(*)(struct SIDL_BaseClass__object *, const char *)) epv->f__cast_ior;
  e0->f__delete = (void (*)(struct SIDL_BaseClass__object *)) epv->f__delete;
  e0->f_addReference = (void (*)(struct SIDL_BaseClass__object *)) epv->f_addReference;
  e0->f_deleteReference = (void (*)(struct SIDL_BaseClass__object *)) epv->f_deleteReference;
  e0->f_isSame = (SIDL_bool (*)(struct SIDL_BaseClass__object *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e0->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(struct SIDL_BaseClass__object *, const char *)) epv->f_queryInterface;
  e0->f_isInstanceOf = (SIDL_bool (*)(struct SIDL_BaseClass__object *, const char *)) epv->f_isInstanceOf;

  e1->f__cast_ior = (void *(*)(void *, const char *)) epv->f__cast_ior;
  e1->f__delete = (void (*)(void *)) epv->f__delete;
  e1->f_addReference = (void (*)(void *)) epv->f_addReference;
  e1->f_deleteReference = (void (*)(void *)) epv->f_deleteReference;
  e1->f_isSame = (SIDL_bool (*)(void *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e1->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(void *, const char *)) epv->f_queryInterface;
  e1->f_isInstanceOf = (SIDL_bool (*)(void *, const char *)) epv->f_isInstanceOf;

  s_method_initialized = 1;
}

/* INIT_SEPV: create static entry point vector (SEPV) structure */
static void SIDL_Loader__init_sepv(void)
{
  struct SIDL_Loader__sepv * s = &s_stc__sidl_loader;

  s->f_setSearchPath = NULL;
  s->f_getSearchPath = NULL;
  s->f_addSearchPath = NULL;
  s->f_loadLibrary = NULL;
  s->f_addDLL = NULL;
  s->f_unloadLibraries = NULL;
  s->f_lookupSymbol = NULL;
  s->f_createClass = NULL;

  SIDL_Loader__set_sepv(s);

  s_static_initialized = 1;
}

/* STATICS: return static EPV structure for static methods */
struct SIDL_Loader__sepv * SIDL_Loader__statics()
{
  if (!s_static_initialized) {
    SIDL_Loader__init_sepv();
  }
  return &s_stc__sidl_loader;
}

/* NEW: allocate object and initialize it */
struct SIDL_Loader__object *SIDL_Loader__new()
{
  struct SIDL_Loader__object *self = (struct SIDL_Loader__object *) malloc(sizeof(struct SIDL_Loader__object));
  SIDL_Loader__init(self);
  return self;
}

/* INIT: initialize a new instance of the class object */
void SIDL_Loader__init(
  struct SIDL_Loader__object *self)
{
  struct SIDL_Loader__object *s0 = self;
  struct SIDL_BaseClass__object *s1 = &s0->d_sidl_baseclass;

#if 1
  SIDL_BaseClass__init(s1);
#else
  void (*dll_f)(struct SIDL_BaseClass__object *) = (void (*)(struct SIDL_BaseClass__object *)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("SIDL_BaseClass__init");

  if (!dll_f) {
    fputs("Unable to find initializer for SIDL.BaseClass; add to SIDL_DLL_PATH\n", stderr);
    exit(1);
  } else {
    (*dll_f)(s1);
  }
#endif

  if (!s_method_initialized) {
    SIDL_Loader__init_epv(s0);
  }

  /* Setup d_epv members */
  s1->d_sidl_baseinterface.d_epv = &s_new__sidl_baseinterface;
  s1->d_epv = &s_new__sidl_baseclass;

  s0->d_epv = &s_new__sidl_loader;

  /* Setup d_object members */
  s1->d_sidl_baseinterface.d_object = self;
  s1->d_object = self;
  s0->d_object = self;

  /* Setup d_data members */
  s0->d_data = NULL;
  (*(self->d_epv->f__ctor))(self);
}

/* FINI: deallocate a class instance (destructor) */
void SIDL_Loader__fini(
  struct SIDL_Loader__object *self)
{
  struct SIDL_Loader__object *s0 = self;
  struct SIDL_BaseClass__object *s1 = &s0->d_sidl_baseclass;
#if 0
  void (*dll_f)(struct SIDL_BaseClass__object *) = (void (*)(struct SIDL_BaseClass__object *)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("SIDL_BaseClass__fini");
#endif

  (*(self->d_epv->f__dtor))(self);

  /* Setup d_epv members */
  s1->d_sidl_baseinterface.d_epv = s_old__sidl_baseinterface;
  s1->d_epv = s_old__sidl_baseclass;

#if 1
  SIDL_BaseClass__fini(s1);
#else
  if (!dll_f) {
    fputs("Unable to find finializer for SIDL.BaseClass; add to SIDL_DLL_PATH\n", stderr);
    exit(1);
  } else {
    (*dll_f)(s1);
  }
#endif
}

/* The IOR array structure */
/*   Macros to read this are defined in SIDLArray.h */
struct SIDL_Loader__array {
  struct SIDL_Loader__object ** d_firstElement;
  int32_t *d_lower;
  int32_t *d_upper;
  int32_t *d_stride;
  SIDL_bool d_borrowed;
  int32_t d_dimen;
};

static struct SIDL_Loader__array *newArray(int32_t dimen, const int32_t lower[], const int32_t upper[]) {
  static const size_t arraySize = sizeof(struct SIDL_Loader__array) + (sizeof(int32_t) - (sizeof(struct SIDL_Loader__array)%sizeof(int32_t)))%sizeof(int32_t);
  struct SIDL_Loader__array *result = (struct SIDL_Loader__array *) malloc(arraySize + 3*sizeof(int32_t)*dimen);

  result->d_dimen    = dimen;
  result->d_borrowed = 0;
  result->d_lower    = (int32_t *) ((char *) result + arraySize);
  result->d_upper    = result->d_lower + dimen;
  result->d_stride   = result->d_upper + dimen;
  memcpy(result->d_lower, lower, sizeof(int32_t)*dimen);
  memcpy(result->d_upper, upper, sizeof(int32_t)*dimen);
  return result;
}

/* Create a dense array of the given dimension with specified index bounds */
/*   This array owns and manages its data */
/*   All object pointers are initialized to NULL */
struct SIDL_Loader__array * SIDL_Loader__iorarray_create(
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[])
{
  struct SIDL_Loader__array *result = newArray(dimen, lower, upper);
  int32_t size;
  int32_t i;

  for(i = 0, size = 1; i < dimen; i++) {
    result->d_stride[i] = size;
    size *= (upper[i] - lower[i] + 1);
  }
  size *= sizeof(struct SIDL_Loader__object *);
  result->d_firstElement = (struct SIDL_Loader__object **) malloc((size_t) size);
  memset(result->d_firstElement, 0, (size_t) size);
  return result;
}

/* Create an array using user-provided memory */
struct SIDL_Loader__array * SIDL_Loader__iorarray_borrow(
  struct SIDL_Loader__object ** firstElement,
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[],
  const int32_t stride[])
{
  struct SIDL_Loader__array *result = newArray(dimen, lower, upper);

  memcpy(result->d_stride, stride, sizeof(int32_t)*dimen);
  result->d_firstElement = firstElement;
  result->d_borrowed     = 1;
  return result;
}

/* Destroy the array (NULL arrays are ignored) */
void SIDL_Loader__iorarray_destroy(
  struct SIDL_Loader__array *array)
{
  if (array) {
    const int32_t dimen = array->d_dimen;

    if (!(array->d_borrowed)) {
      if (dimen > 0) {
        struct SIDL_Loader__object **start = array->d_firstElement;
        struct SIDL_Loader__object **end;
        int32_t size = 1;

        if (dimen > 1) {
          size = array->d_stride[dimen-1];
        }
        size *= (array->d_upper[dimen-1] - array->d_lower[dimen-1] + 1);
        end   = start + size;
        while(start < end) {
          if (*start) {
            (*(((struct SIDL_BaseClass__object *) (*start)->d_object)->d_epv->f_deleteReference))((*start)->d_object);
            *start = NULL;
          }
          ++start;
        }
      }
      free(array->d_firstElement);
    }
    memset(array, 0, sizeof(struct SIDL_Loader__array) + 3*sizeof(int32_t)*dimen);
    free(array);
  }
}

/* Return the number of dimensions in the array */
/*   If the array pointer is NULL, zero is returned */
int32_t SIDL_Loader__iorarray_dimen(
  const struct SIDL_Loader__array *array)
{
  return array ? array->d_dimen : 0;
}

/* Return the lower bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, zero is returned */
int32_t SIDL_Loader__iorarray_lower(
  const struct SIDL_Loader__array *array,
  int32_t ind)
{
  return (array && (ind < array->d_dimen) && (ind >= 0)) ? array->d_lower[ind] : 0;
}

/* Return the upper bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, -1 is returned */
int32_t SIDL_Loader__iorarray_upper(
  const struct SIDL_Loader__array *array,
  int32_t ind)
{
  return (array && (ind < array->d_dimen) && (ind >= 0)) ? array->d_upper[ind] : -1;
}

/* Get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct SIDL_Loader__object * SIDL_Loader__iorarray_get(
  const struct SIDL_Loader__array *array,
  const int32_t indices[])
{
  struct SIDL_Loader__object **result = NULL;
  if (array && (array->d_dimen > 0)) {
    int32_t i;

    result = array->d_firstElement;
    for(i = 0; i < array->d_dimen; i++) {
      if ((indices[i] >= array->d_lower[i]) && (indices[i] <= array->d_upper[i])) {
        result += (array->d_stride[i]*(indices[i] - array->d_lower[i]));
      } else {
        result = NULL;
        break;
      }
    }
  }
  if (result) {
    if (*result) {
      (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_addReference))((*result)->d_object);
    }
    return *result;
  } else {
    return NULL;
  }
}

/* get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct SIDL_Loader__object * SIDL_Loader__iorarray_get4(
  const struct SIDL_Loader__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4)
{
  struct SIDL_Loader__object **result = NULL;
  if (array) {
    result = array->d_firstElement;
    switch(array->d_dimen) {
    case 4:
      if ((i4 >= array->d_lower[3]) && (i4 <= array->d_upper[3])) {
        result += (array->d_stride[3]*(i4 - array->d_lower[3]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 3:
      if ((i3 >= array->d_lower[2]) && (i3 <= array->d_upper[2])) {
        result += (array->d_stride[2]*(i3 - array->d_lower[2]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 2:
      if ((i2 >= array->d_lower[1]) && (i2 <= array->d_upper[1])) {
        result += (array->d_stride[1]*(i2 - array->d_lower[1]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 1:
      if ((i1 >= array->d_lower[0]) && (i1 <= array->d_upper[0])) {
        result += (array->d_stride[0]*(i1 - array->d_lower[0]));
      } else {
        result = NULL;
        break;
      }
      break;
    default:
      result = NULL;
      break;
    }
  }
  if (result) {
    if (*result) {
      (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_addReference))((*result)->d_object);
    }
    return *result;
  } else {
    return NULL;
  }
}

/* Set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void SIDL_Loader__iorarray_set(
  struct SIDL_Loader__array *array,
  const int32_t indices[],
  struct SIDL_Loader__object * value)
{
  struct SIDL_Loader__object **result = NULL;
  if (array && (array->d_dimen > 0)) {
    int32_t i;

    result = array->d_firstElement;
    for(i = 0; i < array->d_dimen; i++) {
      if ((indices[i] >= array->d_lower[i]) && (indices[i] <= array->d_upper[i])) {
        result += (array->d_stride[i]*(indices[i] - array->d_lower[i]));
      } else {
        result = NULL;
        break;
      }
    }
    if (result) {
      if (value) {
        (*(((struct SIDL_BaseClass__object *) value->d_object)->d_epv->f_addReference))(value->d_object);
      }
      if (*result) {
        (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_deleteReference))((*result)->d_object);
      }
      *result = value;
    }
  }
}

/* set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void SIDL_Loader__iorarray_set4(
  struct SIDL_Loader__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4,
  struct SIDL_Loader__object * value)
{
  struct SIDL_Loader__object **result = NULL;
  if (array) {
    result = array->d_firstElement;
    switch(array->d_dimen) {
    case 4:
      if ((i4 >= array->d_lower[3]) && (i4 <= array->d_upper[3])) {
        result += (array->d_stride[3]*(i4 - array->d_lower[3]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 3:
      if ((i3 >= array->d_lower[2]) && (i3 <= array->d_upper[2])) {
        result += (array->d_stride[2]*(i3 - array->d_lower[2]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 2:
      if ((i2 >= array->d_lower[1]) && (i2 <= array->d_upper[1])) {
        result += (array->d_stride[1]*(i2 - array->d_lower[1]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 1:
      if ((i1 >= array->d_lower[0]) && (i1 <= array->d_upper[0])) {
        result += (array->d_stride[0]*(i1 - array->d_lower[0]));
      } else {
        result = NULL;
        break;
      }
      break;
    default:
      result = NULL;
      break;
    }
  }
  if (result) {
    if (value) {
      (*(((struct SIDL_BaseClass__object *) value->d_object)->d_epv->f_addReference))(value->d_object);
    }
    if (*result) {
      (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_deleteReference))((*result)->d_object);
    }
    *result = value;
  }
}

static const struct SIDL_Loader__external s_externalEntryPoints = {
  SIDL_Loader__new,
  NULL /*SIDL_Loader__remote*/,
  SIDL_Loader__statics,
  SIDL_Loader__iorarray_create,
  SIDL_Loader__iorarray_borrow,
  SIDL_Loader__iorarray_destroy,
  SIDL_Loader__iorarray_dimen,
  SIDL_Loader__iorarray_lower,
  SIDL_Loader__iorarray_upper,
  SIDL_Loader__iorarray_get,
  SIDL_Loader__iorarray_get4,
  SIDL_Loader__iorarray_set,
  SIDL_Loader__iorarray_set4
};

/* This function returns a pointer to a static structure of pointers to function entry points */
/* It is called upon loading the DLL */
const struct SIDL_Loader__external *SIDL_Loader__externals()
{
  return &s_externalEntryPoints;
}
