#ifndef included_SIDL_Loader_impl
#include "SIDL/Loader_impl/Loader_impl.hh"
#endif

// DO-NOT-DELETE splicer.begin(SIDL.Loader.lookupSymbol._includes)
// Put additional includes or other arbitrary code here...
// DO-NOT-DELETE splicer.end(SIDL.Loader.lookupSymbol._includes)

void*
SIDL::Loader_impl::lookupSymbol(
  /*in*/ std::string linker_name)
throw ()
{
  // DO-NOT-DELETE splicer.begin(SIDL.Loader.lookupSymbol)
  DLL_List *dll_item = NULL;
  void     *symbol   = NULL;

  // Walk current dll list and check whether any DLL defines the symbol
  SIDL::Loader_impl::initialize_dll_list();
  dll_item = SIDL::Loader_impl::dllList;
  while ((dll_item != NULL) && (symbol == NULL)) {
    symbol   = dll_item->dll.lookupSymbol(linker_name);
    dll_item = dll_item->next;
  }

  // If the symbol was not found, then search the dll search path
  if (!symbol) {
    std::string  path     = SIDL::Loader_impl::getSearchPath();
    unsigned int startPos = 0;
    unsigned int endPos   = path.length();

    while((startPos < path.length()) && (symbol == NULL)) {
      while(path[startPos] == ' ' || path[startPos] == ';' || path[startPos] == ':') startPos++;
      endPos = startPos;
      if (path.substr(startPos, 5) == "http:") endPos += 5;
      if (path.substr(startPos, 5) == "file:") endPos += 5;
      if (path.substr(startPos, 4) == "lib:")  endPos += 4;
      if (path.substr(startPos, 4) == "ftp:")  endPos += 4;
      if (path.substr(startPos, 5) == "main:") endPos += 5;
      while (path[endPos] != ';' && path[endPos] != ':' && endPos < path.length()) endPos++;

      std::string entry = path.substr(startPos, endPos-startPos);

      if (!SIDL::Loader_impl::is_file_uri(entry)) {
        // If the URI is not a file, then try to load it directly.
        symbol = SIDL::Loader_impl::try_load_dll(entry, linker_name);
      } else {
        // If it is a file, then make sure the URI is "file:" with an
        // absolute path using the CWD if necessary.
        std::string file_uri;

        if (entry.substr(0, 6) == "file:/") {
          file_uri = entry;
        } else if (entry.substr(0, 5) == "file:") {
          std::string cwd  = SIDL::Loader_impl::util_getcwd();
          std::string file = entry.substr(5);

          file_uri  = "file:"+cwd+"/"+file;
        } else if (entry[0] == '/') {
          file_uri = "file:"+entry;
        } else {
          std::string cwd = SIDL::Loader_impl::util_getcwd();

          file_uri = "file:"+cwd+"/"+entry;
        }
        symbol = SIDL::Loader_impl::find_symbol(file_uri, linker_name);
      }

      startPos = endPos;
    }
  }

  return symbol;
  // DO-NOT-DELETE splicer.end(SIDL.Loader.lookupSymbol)

}

