#ifndef included_SIDL_Loader_impl
#include "SIDL/Loader_impl/Loader_impl.hh"
#endif
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif

extern "C" {

  void
  SIDL_Loader_setSearchPath_skel(
    /*in*/ const char * path_name)
  {
    // Return value setup
    // Pack arguments for dispatch to implementation
    std::string _local_path_name(path_name);
    // Exception handling setup
    // Dispatch to implementation
  ::SIDL::Loader_impl::setSearchPath(/*in*/ _local_path_name);
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
  }
  
  char *
  SIDL_Loader_getSearchPath_skel(
  )
  {
    // Return value setup
    char * _result;
    std::string _local__result;
    // Pack arguments for dispatch to implementation
    // Exception handling setup
    // Dispatch to implementation
    _local__result =::SIDL::Loader_impl::getSearchPath();
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
    _result = NULL;
    if (_local__result.c_str()) {
      _result = (char *) malloc(strlen(_local__result.c_str())+1);
      strcpy(_result, _local__result.c_str());
    }
    return _result;
  }
  
  void
  SIDL_Loader_addSearchPath_skel(
    /*in*/ const char * path_fragment)
  {
    // Return value setup
    // Pack arguments for dispatch to implementation
    std::string _local_path_fragment(path_fragment);
    // Exception handling setup
    // Dispatch to implementation
  ::SIDL::Loader_impl::addSearchPath(/*in*/ _local_path_fragment);
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
  }
  
  SIDL_bool
  SIDL_Loader_loadLibrary_skel(
    /*in*/ const char * uri)
  {
    // Return value setup
    SIDL_bool _result;
    bool _local__result;
    // Pack arguments for dispatch to implementation
    std::string _local_uri(uri);
    // Exception handling setup
    // Dispatch to implementation
    _local__result =::SIDL::Loader_impl::loadLibrary(/*in*/ _local_uri);
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
    _result = (_local__result ? TRUE : FALSE);
    return _result;
  }
  
  void
  SIDL_Loader_addDLL_skel(
    /*in*/ struct SIDL_DLL__object * dll)
  {
    // Return value setup
    // Pack arguments for dispatch to implementation
    ::SIDL::DLL _local_dll(dll);
    // Exception handling setup
    // Dispatch to implementation
  ::SIDL::Loader_impl::addDLL(/*in*/ _local_dll);
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
  }
  
  void
  SIDL_Loader_unloadLibraries_skel(
  )
  {
    // Return value setup
    // Pack arguments for dispatch to implementation
    // Exception handling setup
    // Dispatch to implementation
  ::SIDL::Loader_impl::unloadLibraries();
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
  }
  
  void *
  SIDL_Loader_lookupSymbol_skel(
    /*in*/ const char * linker_name)
  {
    // Return value setup
    void * _result;
    // Pack arguments for dispatch to implementation
    std::string _local_linker_name(linker_name);
    // Exception handling setup
    // Dispatch to implementation
    _result =::SIDL::Loader_impl::lookupSymbol(/*in*/ _local_linker_name);
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
    return _result;
  }
  
  struct SIDL_BaseClass__object *
  SIDL_Loader_createClass_skel(
    /*in*/ const char * sidl_name)
  {
    // Return value setup
    struct SIDL_BaseClass__object * _result;
    ::SIDL::BaseClass _local__result;
    // Pack arguments for dispatch to implementation
    std::string _local_sidl_name(sidl_name);
    // Exception handling setup
    // Dispatch to implementation
    _local__result =::SIDL::Loader_impl::createClass(/*in*/ _local_sidl_name);
    // Exception handling cleanup
    // Unpack arguments from dispatch to implementation
    // Return value cleanup
    if (_local__result._not_nil()) {
      _local__result.addReference();
    }
    _result = _local__result._get_ior();
    return _result;
  }
  
  void SIDL_Loader__ctor_skel(struct SIDL_Loader__object *self) {
    self->d_data = reinterpret_cast< void * >(new ::SIDL::Loader_impl(self));
  }
  
  void SIDL_Loader__dtor_skel(struct SIDL_Loader__object *self) {
    delete(reinterpret_cast< ::SIDL::Loader_impl * >(self->d_data));
  }
  
  void
  SIDL_Loader__set_epv(struct SIDL_Loader__epv * epv) {
    // Initialize constructor and destructor
    epv->f__ctor = SIDL_Loader__ctor_skel;
    epv->f__dtor = SIDL_Loader__dtor_skel;
  }
  
  void
  SIDL_Loader__set_sepv(struct SIDL_Loader__sepv * sepv) {
    // Initialize user methods
    sepv->f_setSearchPath = SIDL_Loader_setSearchPath_skel;
    sepv->f_getSearchPath = SIDL_Loader_getSearchPath_skel;
    sepv->f_addSearchPath = SIDL_Loader_addSearchPath_skel;
    sepv->f_loadLibrary = SIDL_Loader_loadLibrary_skel;
    sepv->f_addDLL = SIDL_Loader_addDLL_skel;
    sepv->f_unloadLibraries = SIDL_Loader_unloadLibraries_skel;
    sepv->f_lookupSymbol = SIDL_Loader_lookupSymbol_skel;
    sepv->f_createClass = SIDL_Loader_createClass_skel;
  }
  
} // end extern "C"

