# DO-NOT-DELETE splicer.begin(_initial)
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.BaseClass
import SIDL.BaseInterface

# DO-NOT-DELETE splicer.begin(_before_type)
pass
# DO-NOT-DELETE splicer.end(_before_type)

class DLL:
  '''
  // The <code>DLL</code> class encapsulates access to a single
  // dynamically linked library.  DLLs are loaded at run-time using
  // the <code>loadLibrary</code> method and later unloaded using
  // <code>unloadLibrary</code>.  Symbols in a loaded library are
  // resolved to an opaque pointer by method <code>lookupSymbol</code>.
  // Class instances are created by <code>createClass</code>.
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.handle = 0
    self.name   = ''
    self.file   = ''
    # DO-NOT-DELETE splicer.end(__init__)

  def loadLibrary(self, uri):
    '''
    // Load a dynamic link library using the specified URI.  The
    // URI may be of the form \"main:\", \"lib:\", \"file:\", \"ftp:\", or
    // \"http:\".  A URI that starts with any other protocol string
    // is assumed to be a file name.  The \"main:\" URI creates a
    // library that allows access to global symbols in the running
    // program\'s main address space.  The \"lib:X\" URI converts the
    // library \"X\" into a platform-specific name (e.g., libX.so) and
    // loads that library.  The \"file:\" URI opens the DLL from the
    // specified file path.  The \"ftp:\" and \"http:\" URIs copy the
    // specified library from the remote site into a local temporary
    // file and open that file.  This method returns true if the
    // DLL was loaded successfully and false otherwise.  Note that
    // the \"ftp:\" and \"http:\" protocols are valid only if the W3C
    // WWW library is available.
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # uri string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(loadLibrary)
    if self.handle:
      self.unloadLibrary()
    if uri == 'main:':
      self.name = uri
      self.file = ''
    elif uri.startswith('lib:'):
      self.name = uri
      # Need to check for cygwin here, to use 'cyg'...'.dll'
      self.file = 'lib'+uri[4:]+'.so'
    elif uri.startswith('file:'):
      self.name = uri
      self.file = uri[5:]
    elif uri.startswith('ftp:') or uri.startswith('http:'):
      self.name = uri
      # TODO: Use correct temporary file
      self.file = 'tmpfile'
    else:
      self.name = 'file:'+uri
      self.file = uri
    # TODO: dlopen(self.file)
    if not self.handle:
      import sys
      sys.stderr.write('Unable to dlopen() file '+self.file+', error message '+errorMessage+'\n')
    return self.handle
    # DO-NOT-DELETE splicer.end(loadLibrary)

  def getLibraryName(self):
    '''
    // Get the library name.  This is the name used to load the
    // library in <code>loadLibrary</code> except that all file names
    // contain the \"file:\" protocol.
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getLibraryName)
    pass
    # DO-NOT-DELETE splicer.end(getLibraryName)

  def unloadLibrary(self):
    '''
    // Unload the dynamic link library.  The library may no longer
    // be used to access symbol names.  When the library is actually
    // unloaded from the memory image depends on details of the operating
    // system.
    '''
    # DO-NOT-DELETE splicer.begin(unloadLibrary)
    return self.name
    # DO-NOT-DELETE splicer.end(unloadLibrary)

  def lookupSymbol(self, linker_name):
    '''
    // Lookup a symbol from the DLL and return the associated pointer.
    // A null value is returned if the name does not exist.
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # linker_name string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # opaque _return
    # DO-NOT-DELETE splicer.begin(lookupSymbol)
    address = 0
    if self.handle:
      #TODO: dlsym(self.handle, linker_name)
      pass
    return address
    # DO-NOT-DELETE splicer.end(lookupSymbol)

  def createClass(self, sidl_name):
    '''
    // Create an instance of the SIDL class.  If the class constructor
    // is not defined in this DLL, then return null.
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # sidl_name string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDL.BaseClass _return
    # DO-NOT-DELETE splicer.begin(createClass)
    if self.handle:
      # TODO: ctor = dlsym(self.handle, sidl_name.replace('.', '_')+'__new')
      # TODO: __wrap((*ctor)())
      obj = SIDL.BaseClass.BaseClass()
    else:
      obj = None
    return obj
    # DO-NOT-DELETE splicer.end(createClass)

# DO-NOT-DELETE splicer.begin(_final)
pass
# DO-NOT-DELETE splicer.end(_final)

