# DO-NOT-DELETE splicer.begin(_initial)
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.DLL
import SIDL.BaseClass
import SIDL.BaseInterface

# DO-NOT-DELETE splicer.begin(_before_static)
import os

searchPath = []
if os.environ.has_key('SIDL_DLL_PATH'):
  searchPath += os.environ['SIDL_DLL_PATH'].replace(';', ':').split(':')
if os.environ.has_key('PYTHONPATH'):
  searchPath += os.environ['PYTHONPATH'].split(':')

dllList = []
# DO-NOT-DELETE splicer.end(_before_static)

def setSearchPath(path_name):
  '''
  // Set the search path, which is a semi-colon separated sequence of
  // URIs as described in class <code>DLL</code>.  This method will
  // invalidate any existing search path.
  '''
  # SIDL EXPECTED INCOMING TYPES
  # ============================
  # path_name string
  # DO-NOT-DELETE splicer.begin(setSearchPath)
  if path_name:
    self.searchPath = os.environ['SIDL_DLL_PATH'].replace(';', ':').split(':')
  else:
    self.searchPath = []
  # DO-NOT-DELETE splicer.end(setSearchPath)

def getSearchPath():
  '''
  // Return the current search path.  If the search path has not been
  // set, then the search path will be taken from environment variable
  // SIDL_DLL_PATH.
  '''
  # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
  # ================================================================
  # string _return
  # DO-NOT-DELETE splicer.begin(getSearchPath)
  path = ''
  for i in range(len(searchPath)):
    path += searchPath[i]
    if i < len(searchPath)-1: path += ':'
  return path
  # DO-NOT-DELETE splicer.end(getSearchPath)

def addSearchPath(path_fragment):
  '''
  // Append the specified path fragment to the beginning of the
  // current search path.  If the search path has not yet been set
  // by a call to <code>setSearchPath</code>, then this fragment will
  // be appended to the path in environment variable SIDL_DLL_PATH.
  '''
  # SIDL EXPECTED INCOMING TYPES
  # ============================
  # path_fragment string
  # DO-NOT-DELETE splicer.begin(addSearchPath)
  if path_fragment:
    searchPath.append(path_fragment)
  # DO-NOT-DELETE splicer.end(addSearchPath)

def loadLibrary(uri):
  '''
  // Load the specified library if it has not already been loaded.
  // The URI format is defined in class <code>DLL</code>.  The search
  // path is not searched to resolve the library name.
  '''
  # SIDL EXPECTED INCOMING TYPES
  # ============================
  # uri string
  # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
  # ================================================================
  # bool _return
  # DO-NOT-DELETE splicer.begin(loadLibrary)
  dll = SIDL.DLL.DLL()
  ok  = dll.loadLibrary(uri)

  if ok:
    self.addDLL(dll)
  dll.deleteReference()
  return ok
  # DO-NOT-DELETE splicer.end(loadLibrary)

def addDLL(dll):
  '''
  // Append the specified DLL to the beginning of the list of already
  // loaded DLLs.
  '''
  # SIDL EXPECTED INCOMING TYPES
  # ============================
  # dll SIDL.DLL
  # DO-NOT-DELETE splicer.begin(addDLL)
  dll.addReference()
  dllList.append(dll)
  # DO-NOT-DELETE splicer.end(addDLL)

def unloadLibraries():
  '''
  // Unload all dynamic link libraries.  The library may no longer
  // be used to access symbol names.  When the library is actually
  // unloaded from the memory image depends on details of the operating
  // system.
  '''
  # DO-NOT-DELETE splicer.begin(unloadLibraries)
  for dll in dllList:
    dll.deleteReference()
  dllList = []
  # DO-NOT-DELETE splicer.end(unloadLibraries)

def lookupSymbol(linker_name):
  '''
  // Look up the secified symbol name.  If the symbol name cannot be
  // found in one of the already loaded libraries, then the method will
  // search through the library search path.  A null is returned if the
  // symbol could not be resolved.
  '''
  # SIDL EXPECTED INCOMING TYPES
  # ============================
  # linker_name string
  # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
  # ================================================================
  # opaque _return
  # DO-NOT-DELETE splicer.begin(lookupSymbol)
  for dll in dllList:
    symbol = dll.lookupSymbol(linker_name)
    if symbol: return symbol
  # Search path
  for dir in searchPath:
    if not isFileUri(dir):
      symbol = findSymbolInDLL(dir, linker_name)
    else:
      if dir.startswith('file:'):
        uri = 'file:'+os.path.abspath(dir[5:])
      else:
        uri = 'file:'+os.path.abspath(dir)
      symbol = findSymbol(uri, linker_name)
    if symbol: return symbol
  return 0
  # DO-NOT-DELETE splicer.end(lookupSymbol)

def createClass(sidl_name):
  '''
  // Create an instance of the specified SIDL class.  If the class
  // constructor cannot be found in one of the already loaded libraries,
  // then the method will search through the library search path.  A null
  // object is returned if the symbol could not be resolved.
  '''
  # SIDL EXPECTED INCOMING TYPES
  # ============================
  # sidl_name string
  # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
  # ================================================================
  # SIDL.BaseClass _return
  # DO-NOT-DELETE splicer.begin(createClass)
  pass
  # DO-NOT-DELETE splicer.end(createClass)

# DO-NOT-DELETE splicer.begin(_before_type)
pass
# DO-NOT-DELETE splicer.end(_before_type)

class Loader:
  '''
  // Class <code>Loader</code> manages dyanamic loading and symbol name
  // resolution for the SIDL runtime system.  The <code>Loader</code> class
  // manages a library search path and keeps a record of all libraries
  // loaded through this interface, including the initial \"global\" symbols
  // in the main program.  Unless explicitly set, the search path is taken
  // from the environment variable SIDL_DLL_PATH, which is a semi-colon
  // separated sequence of URIs as described in class <code>DLL</code>.
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    pass
    # DO-NOT-DELETE splicer.end(__init__)

# DO-NOT-DELETE splicer.begin(_final)
def isFileUri(uri):
  if uri.startswith('file:'):
    isFile = 1
  elif uri.startswith('main:'):
    isFile = 0
  elif uri.startswith('lib:'):
    isFile = 0
  elif uri.startswith('ftp:'):
    isFile = 0
  elif uri.startswith('http:'):
    isFile = 0
  else:
    isFile = 1
  return isFile

def isLoaded(uri):
  for dll in dllList:
    if uri == dll.getLibraryName():
      return 1
  return 0

def findSymbolInDLL(uri, name):
  symbol = 0

  if not isLoaded(uri):
    dll = SIDL.DLL.DLL()

    if dll.loadLibrary(uri):
      addDLL(dll)
      symbol = dll.lookupSymbol(name)
    dll.deleteReference()
  return symbol

def findSymbol(uri, name):
  if not uri.startswith('file:'): return 0
  path = uri[5:]

  if os.path.isdir(path):
    for entry in os.listdir(path):
      symbol = findSymbol(os.path.join(uri, entry), name)
      if symbol: return symbol
  else:
    if path.endswith('.la') or path.endswith('.so') or path.endswith('.dll'):
      findSymbolInDLL(uri, name)
  return 0
# DO-NOT-DELETE splicer.end(_final)

